/**
 * freesewing | v0.22.1
 * A library for creating made-to-measure sewing patterns
 * (c) 2018 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
var freesewing=function(t){"use strict";function i(){this.list={}}function r(t,r){this.x=O(t),this.y=O(r),this.attributes=new i}function e(t,i){return t(i={exports:{}},i.exports),i.exports}t=t&&t.hasOwnProperty("default")?t.default:t,i.prototype.add=function(t,i){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(i),this},i.prototype.set=function(t,i){return this.list[t]=[i],this},i.prototype.remove=function(t){return delete this.list[t],this},i.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},i.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},i.prototype.render=function(){var t="";for(var i in this.list)t+=" "+i+'="'+this.list[i].join(" ")+'"';return t},i.prototype.renderAsCss=function(){var t="";for(var i in this.list)t+=" "+i+":"+this.list[i].join(" ")+";";return t},i.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",i="",r=t.length;for(var e in this.list)e.substr(0,r)===t&&(i+=" "+e.substr(r)+'="'+this.list[e].join(" ")+'"');return i},i.prototype.clone=function(){var t=new i;return t.list=JSON.parse(JSON.stringify(this.list)),t},r.prototype.rad2deg=function(t){return 57.29577951308232*t},r.prototype.deg2rad=function(t){return t/57.29577951308232},r.prototype.attr=function(t,i){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,i):this.attributes.add(t,i),this},r.prototype.dist=function(t){var i=this.x-t.x,r=this.y-t.y;return O(Math.sqrt(Math.pow(i,2)+Math.pow(r,2)))},r.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},r.prototype.dx=function(t){return t.x-this.x},r.prototype.dy=function(t){return t.y-this.y},r.prototype.angle=function(t){for(var i=Math.atan2(-1*this.dy(t),this.dx(t));i<0;)i+=2*Math.PI;return this.rad2deg(i)},r.prototype.rotate=function(t,i){var e=this.dist(i),n=this.angle(i);return new r(i.x+e*Math.cos(this.deg2rad(n+t))*-1,i.y+e*Math.sin(this.deg2rad(n+t)))},r.prototype.copy=function(){return new r(this.x,this.y)},r.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new r(!1===t?-1*this.x:t.x+this.dx(t),this.y)},r.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new r(this.x,!1===t?-1*this.y:t.y+this.dy(t))},r.prototype.shift=function(t,i){var r=this.copy();return r.x+=i,r.rotate(t,this)},r.prototype.shiftTowards=function(t,i){return this.shift(this.angle(t),i)},r.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},r.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},r.prototype.shiftFractionTowards=function(t,i){return this.shiftTowards(t,this.dist(t)*i)},r.prototype.shiftOutwards=function(t,i){return this.shiftTowards(t,this.dist(t)+i)},r.prototype.clone=function(){var t=new r(this.x,this.y);return t.attributes=this.attributes.clone(),t},r.prototype.translate=function(t,i){var r=this.copy();return r.x+=t,r.y+=i,r};var n=e(function(t){var i,r,e,n,o,s,a,h,p,f,y,c,l,d;i=Math.abs,r=Math.cos,e=Math.sin,n=Math.acos,o=Math.atan2,s=Math.sqrt,a=Math.pow,h=function(t){return t<0?-a(-t,1/3):a(t,1/3)},p=Math.PI,f=2*p,y=p/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,l=Number.MIN_SAFE_INTEGER||-9007199254740991,d={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,i){var r=i(t),e=r.x*r.x+r.y*r.y;return void 0!==r.z&&(e+=r.z*r.z),s(e)},between:function(t,i,r){return i<=t&&t<=r||d.approximately(t,i)||d.approximately(t,r)},approximately:function(t,r,e){return i(t-r)<=(e||1e-6)},length:function(t){var i,r,e=0,n=d.Tvalues.length;for(i=0;i<n;i++)r=.5*d.Tvalues[i]+.5,e+=d.Cvalues[i]*d.arcfn(r,t);return.5*e},map:function(t,i,r,e,n){return e+(n-e)*((t-i)/(r-i))},lerp:function(t,i,r){var e={x:i.x+t*(r.x-i.x),y:i.y+t*(r.y-i.y)};return i.z&&r.z&&(e.z=i.z+t*(r.z-i.z)),e},pointToString:function(t){var i=t.x+"/"+t.y;return void 0!==t.z&&(i+="/"+t.z),i},pointsToString:function(t){return"["+t.map(d.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,i,r){var e=i.x-t.x,n=i.y-t.y,s=r.x-t.x,a=r.y-t.y;return o(e*a-n*s,e*s+n*a)},round:function(t,i){var r=""+t,e=r.indexOf(".");return parseFloat(r.substring(0,e+1+i))},dist:function(t,i){var r=t.x-i.x,e=t.y-i.y;return s(r*r+e*e)},closest:function(t,i){var r,e,n=a(2,63);return t.forEach(function(t,o){(e=d.dist(i,t))<n&&(n=e,r=o)}),{mdist:n,mpos:r}},abcratio:function(t,r){if(2!==r&&3!==r)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var e=a(t,r)+a(1-t,r);return i((e-1)/e)},projectionratio:function(t,i){if(2!==i&&3!==i)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var r=a(1-t,i);return r/(a(t,i)+r)},lli8:function(t,i,r,e,n,o,s,a){var h=(t-r)*(o-a)-(i-e)*(n-s);return 0!=h&&{x:((t*e-i*r)*(n-s)-(t-r)*(n*a-o*s))/h,y:((t*e-i*r)*(o-a)-(i-e)*(n*a-o*s))/h}},lli4:function(t,i,r,e){var n=t.x,o=t.y,s=i.x,a=i.y,h=r.x,p=r.y,u=e.x,f=e.y;return d.lli8(n,o,s,a,h,p,u,f)},lli:function(t,i){return d.lli4(t,t.c,i,i.c)},makeline:function(t,i){var r=u,e=t.x,n=t.y,o=i.x,s=i.y,a=(o-e)/3,h=(s-n)/3;return new r(e,n,e+a,n+h,e+2*a,n+2*h,o,s)},findbbox:function(t){var i=c,r=c,e=l,n=l;return t.forEach(function(t){var o=t.bbox();i>o.x.min&&(i=o.x.min),r>o.y.min&&(r=o.y.min),e<o.x.max&&(e=o.x.max),n<o.y.max&&(n=o.y.max)}),{x:{min:i,mid:(i+e)/2,max:e,size:e-i},y:{min:r,mid:(r+n)/2,max:n,size:n-r}}},shapeintersections:function(t,i,r,e,n){if(!d.bboxoverlap(i,e))return[];var o=[],s=[t.startcap,t.forward,t.back,t.endcap],a=[r.startcap,r.forward,r.back,r.endcap];return s.forEach(function(i){i.virtual||a.forEach(function(e){if(!e.virtual){var s=i.intersects(e,n);s.length>0&&(s.c1=i,s.c2=e,s.s1=t,s.s2=r,o.push(s))}})}),o},makeshape:function(t,i,r){var e=i.points.length,n=t.points.length,o=d.makeline(i.points[e-1],t.points[0]),s=d.makeline(t.points[n-1],i.points[0]),a={startcap:o,forward:t,back:i,endcap:s,bbox:d.findbbox([o,t,i,s])},h=d;return a.intersections=function(t){return h.shapeintersections(a,a.bbox,t,t.bbox,r)},a},getminmax:function(t,i,r){if(!r)return{min:0,max:0};var e,n,o=c,s=l;-1===r.indexOf(0)&&(r=[0].concat(r)),-1===r.indexOf(1)&&r.push(1);for(var a=0,h=r.length;a<h;a++)e=r[a],(n=t.get(e))[i]<o&&(o=n[i]),n[i]>s&&(s=n[i]);return{min:o,mid:(o+s)/2,max:s,size:s-o}},align:function(t,i){var n=i.p1.x,s=i.p1.y,a=-o(i.p2.y-s,i.p2.x-n);return t.map(function(t){return{x:(t.x-n)*r(a)-(t.y-s)*e(a),y:(t.x-n)*e(a)+(t.y-s)*r(a)}})},roots:function(t,i){i=i||{p1:{x:0,y:0},p2:{x:1,y:0}};var e=t.length-1,o=d.align(t,i),a=function(t){return 0<=t&&t<=1};if(2===e){if(0!==(v=(x=o[0].y)-2*(g=o[1].y)+(m=o[2].y))){var p=-s(g*g-x*m),u=-x+g;return[-(p+u)/v,-(-p+u)/v].filter(a)}return g!==m&&0===v?[(2*g-m)/2*(g-m)].filter(a):[]}var y=o[0].y,c=o[1].y,l=o[2].y,v=3*c-y-3*l+o[3].y,x=3*y-6*c+3*l,g=-3*y+3*c,m=y;if(d.approximately(v,0)){if(d.approximately(x,0))return d.approximately(g,0)?[]:[-m/g].filter(a);var w=2*x;return[((b=s(g*g-4*x*m))-g)/w,(-g-b)/w].filter(a)}var b,z,S=(o=(3*(g/=v)-(x/=v)*x)/3)/3,O=(b=(2*x*x*x-9*x*g+27*(m/=v))/27)/2,_=O*O+S*S*S;if(_<0){var M=-o/3,k=s(M*M*M),P=-b/(2*k),R=n(P<-1?-1:P>1?1:P),L=2*h(k);return[L*r(R/3)-x/3,L*r((R+f)/3)-x/3,L*r((R+2*f)/3)-x/3].filter(a)}if(0===_)return[2*(z=O<0?h(-O):-h(O))-x/3,-z-x/3].filter(a);var j=s(_);return[(z=h(-O+j))-h(O+j)-x/3].filter(a)},droots:function(t){if(3===t.length){var i=t[0],r=t[1],e=t[2],n=i-2*r+e;if(0!==n){var o=-s(r*r-i*e),a=-i+r;return[-(o+a)/n,-(-o+a)/n]}return r!==e&&0===n?[(2*r-e)/(2*(r-e))]:[]}if(2===t.length)return(i=t[0])!==(r=t[1])?[i/(i-r)]:[]},inflections:function(t){if(t.length<4)return[];var i=d.align(t,{p1:t[0],p2:t.slice(-1)[0]}),r=i[2].x*i[1].y,e=i[3].x*i[1].y,n=i[1].x*i[2].y,o=18*(-3*r+2*e+3*n-(f=i[3].x*i[2].y)),s=18*(3*r-e-3*n),a=18*(n-r);if(d.approximately(o,0)){if(!d.approximately(s,0)){var h=-a/s;if(0<=h&&h<=1)return[h]}return[]}var p=s*s-4*o*a,u=Math.sqrt(p),f=2*o;return d.approximately(f,0)?[]:[(u-s)/f,-(s+u)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,r){var e,n,o,s,a,h=["x","y"],p=h.length;for(e=0;e<p;e++)if(o=t[n=h[e]].mid,s=r[n].mid,a=(t[n].size+r[n].size)/2,i(o-s)>=a)return!1;return!0},expandbox:function(t,i){i.x.min<t.x.min&&(t.x.min=i.x.min),i.y.min<t.y.min&&(t.y.min=i.y.min),i.z&&i.z.min<t.z.min&&(t.z.min=i.z.min),i.x.max>t.x.max&&(t.x.max=i.x.max),i.y.max>t.y.max&&(t.y.max=i.y.max),i.z&&i.z.max>t.z.max&&(t.z.max=i.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,i,r){var e=t.bbox(),n=i.bbox(),o=1e5,s=r||.5;if(e.x.size+e.y.size<s&&n.x.size+n.y.size<s)return[(o*(t._t1+t._t2)/2|0)/o+"/"+(o*(i._t1+i._t2)/2|0)/o];var a=t.split(.5),h=i.split(.5),p=[{left:a.left,right:h.left},{left:a.left,right:h.right},{left:a.right,right:h.right},{left:a.right,right:h.left}];p=p.filter(function(t){return d.bboxoverlap(t.left.bbox(),t.right.bbox())});var u=[];return 0===p.length?u:(p.forEach(function(t){u=u.concat(d.pairiteration(t.left,t.right,s))}),u=u.filter(function(t,i){return u.indexOf(t)===i}))},getccenter:function(t,i,n){var s,a=i.x-t.x,h=i.y-t.y,p=n.x-i.x,u=n.y-i.y,c=a*r(y)-h*e(y),l=a*e(y)+h*r(y),v=p*r(y)-u*e(y),x=p*e(y)+u*r(y),g=(t.x+i.x)/2,m=(t.y+i.y)/2,w=(i.x+n.x)/2,b=(i.y+n.y)/2,z=g+c,S=m+l,O=w+v,_=b+x,M=d.lli8(g,m,z,S,w,b,O,_),k=d.dist(M,t),P=o(t.y-M.y,t.x-M.x),R=o(i.y-M.y,i.x-M.x),L=o(n.y-M.y,n.x-M.x);return P<L?((P>R||R>L)&&(P+=f),P>L&&(s=L,L=P,P=s)):L<R&&R<P?(s=L,L=P,P=s):L+=f,M.s=P,M.e=L,M.r=k,M},numberSort:function(t,i){return t-i}},t.exports=d}),o=e(function(t){var i,r;i=n,(r=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return i.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,i){return t+i})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,r=t[0].bbox(),e=1;e<t.length;e++)i.expandbox(r,t[e].bbox());return r},offset:function(t){var i=[];return this.curves.forEach(function(r){i=i.concat(r.offset(t))}),new r(i)}},t.exports=r});var s=function(t){var i,r,e,n,o,s,a=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),h=a.length,p=[],u=0,f=0,y=0,c=0,l=0,d=0,v=0,x=0,g="";for(i=1;i<h;i++)if(n=(e=(r=a[i]).substring(0,1)).toLowerCase(),o=(p=(p=r.replace(e,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===n){if(g+="M ","m"===e?(y+=p[0],c+=p[1]):(y=p[0],c=p[1]),u=y,f=c,g+=y+" "+c+" ",o>2)for(s=0;s<o;s+=2)"m"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ")}else if("l"===n)for(s=0;s<o;s+=2)"l"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ");else if("h"===n)for(s=0;s<o;s++)"h"===e?y+=p[s]:y=p[s],g+=["L",y,c,""].join(" ");else if("v"===n)for(s=0;s<o;s++)"v"===e?c+=p[s]:c=p[s],g+=["L",y,c,""].join(" ");else if("q"===n)for(s=0;s<o;s+=4)"q"===e?(l=y+p[s],d=c+p[s+1],y+=p[s+2],c+=p[s+3]):(l=p[s],d=p[s+1],y=p[s+2],c=p[s+3]),g+=["Q",l,d,y,c,""].join(" ");else if("t"===n)for(s=0;s<o;s+=2)l=y+(y-l),d=c+(c-d),"t"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["Q",l,d,y,c,""].join(" ");else if("c"===n)for(s=0;s<o;s+=6)"c"===e?(l=y+p[s],d=c+p[s+1],v=y+p[s+2],x=c+p[s+3],y+=p[s+4],c+=p[s+5]):(l=p[s],d=p[s+1],v=p[s+2],x=p[s+3],y=p[s+4],c=p[s+5]),g+=["C",l,d,v,x,y,c,""].join(" ");else if("s"===n)for(s=0;s<o;s+=4)l=y+(y-v),d=c+(c-x),"s"===e?(v=y+p[s],x=c+p[s+1],y+=p[s+2],c+=p[s+3]):(v=p[s],x=p[s+1],y=p[s+2],c=p[s+3]),g+=["C",l,d,v,x,y,c,""].join(" ");else"z"===n&&(g+="Z ",y=u,c=f);return g.trim()},a={x:!1,y:!1};function h(t,i,r){if("Z"!==i){if("M"!==i){var e=[!1,a.x,a.y].concat(r),n=new(t.bind.apply(t,e)),o=r.slice(-2);return a={x:o[0],y:o[1]},n}a={x:r[0],y:r[1]}}}var p=function(t,i){for(var r,e,n=s(i).split(" "),o=new RegExp("[MLCQZ]",""),a=[],p={C:6,Q:4,L:2,M:2};n.length;)r=n.splice(0,1)[0],o.test(r)&&(e=h(t,r,n.splice(0,p[r]).map(parseFloat)))&&a.push(e);return new t.PolyBezier(a)},u=e(function(t){!function(){var i=Math.abs,r=Math.min,e=Math.max,s=Math.cos,a=Math.sin,h=Math.acos,u=Math.sqrt,f=Math.PI,y={x:0,y:0,z:0},c=n,l=o,d=function(t){var r=t&&t.forEach?t:[].slice.call(arguments),e=!1;if("object"==typeof r[0]){e=r.length;var n=[];r.forEach(function(t){["x","y","z"].forEach(function(i){void 0!==t[i]&&n.push(t[i])})}),r=n}var o=!1,s=r.length;if(e){if(e>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");o=!0}}else if(6!==s&&8!==s&&9!==s&&12!==s&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var a=!o&&(9===s||12===s)||t&&t[0]&&void 0!==t[0].z;this._3d=a;for(var h=[],p=0,u=a?3:2;p<s;p+=u){var f={x:r[p],y:r[p+1]};a&&(f.z=r[p+2]),h.push(f)}this.order=h.length-1,this.points=h;var y=["x","y"];a&&y.push("z"),this.dims=y,this.dimlen=y.length,function(t){for(var r=t.order,e=t.points,n=c.align(e,{p1:e[0],p2:e[r]}),o=0;o<n.length;o++)if(i(n[o].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},v=p;function x(t,i,r,e,n){void 0===n&&(n=.5);var o=c.projectionratio(n,t),s=1-o,a={x:o*i.x+s*e.x,y:o*i.y+s*e.y},h=c.abcratio(n,t);return{A:{x:r.x+(r.x-a.x)/h,y:r.y+(r.y-a.y)/h},B:r,C:a}}d.SVGtoBeziers=function(t){return v(d,t)},d.quadraticFromPoints=function(t,i,r,e){if(void 0===e&&(e=.5),0===e)return new d(i,i,r);if(1===e)return new d(t,i,i);var n=x(2,t,i,r,e);return new d(t,n.A,r)},d.cubicFromPoints=function(t,i,r,e,n){void 0===e&&(e=.5);var o=x(3,t,i,r,e);void 0===n&&(n=c.dist(i,o.C));var s=n*(1-e)/e,a=c.dist(t,r),h=(r.x-t.x)/a,p=(r.y-t.y)/a,u=n*h,f=n*p,y=s*h,l=s*p,v=i.x-u,g=i.y-f,m=i.x+y,w=i.y+l,b=o.A,z=b.x+(v-b.x)/(1-e),S=b.y+(g-b.y)/(1-e),O=b.x+(m-b.x)/e,_=b.y+(w-b.y)/e,M={x:t.x+(z-t.x)/e,y:t.y+(S-t.y)/e},k={x:r.x+(O-r.x)/(1-e),y:r.y+(_-r.y)/(1-e)};return new d(t,M,k,r)};var g=function(){return c};d.getUtils=g,d.PolyBezier=l,d.prototype={getUtils:g,valueOf:function(){return this.toString()},toString:function(){return c.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var i=this.points,r=["M",i[0].x,i[0].y,2===this.order?"Q":"C"],e=1,n=i.length;e<n;e++)r.push(i[e].x),r.push(i[e].y);return r.join(" ")},update:function(){this.dpoints=[];for(var t=this.points,i=t.length,r=i-1;i>1;i--,r--){for(var e,n=[],o=0;o<r;o++)e={x:r*(t[o+1].x-t[o].x),y:r*(t[o+1].y-t[o].y)},this._3d&&(e.z=r*(t[o+1].z-t[o].z)),n.push(e);this.dpoints.push(n),t=n}this.computedirection()},computedirection:function(){var t=this.points,i=c.angle(t[0],t[this.order],t[1]);this.clockwise=i>0},length:function(){return c.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var i=0;i<=t;i++)this._lut.push(this.compute(i/t));return this._lut},on:function(t,i){i=i||5;for(var r,e=this.getLUT(),n=[],o=0,s=0;s<e.length;s++)r=e[s],c.dist(r,t)<i&&(n.push(r),o+=s/e.length);return!!n.length&&o/n.length},project:function(t){var i=this.getLUT(),r=i.length-1,e=c.closest(i,t),n=e.mdist,o=e.mpos;if(0===o||o===r){var s=o/r,a=this.compute(s);return a.t=s,a.d=n,a}var h,p,u,f=(o+1)/r,y=.1/r;for(n+=1,h=s=(o-1)/r;s<f+y;s+=y)p=this.compute(s),(u=c.dist(t,p))<n&&(n=u,h=s);return(p=this.compute(h)).t=h,p.d=n,p},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){if(0===t)return this.points[0];if(1===t)return this.points[this.order];var i=this.points,r=1-t;if(1===this.order)return p={x:r*i[0].x+t*i[1].x,y:r*i[0].y+t*i[1].y},this._3d&&(p.z=r*i[0].z+t*i[1].z),p;if(this.order<4){var e,n,o,s=r*r,a=t*t,h=0;2===this.order?(i=[i[0],i[1],i[2],y],e=s,n=r*t*2,o=a):3===this.order&&(e=s*r,n=s*t*3,o=r*a*3,h=t*a);var p={x:e*i[0].x+n*i[1].x+o*i[2].x+h*i[3].x,y:e*i[0].y+n*i[1].y+o*i[2].y+h*i[3].y};return this._3d&&(p.z=e*i[0].z+n*i[1].z+o*i[2].z+h*i[3].z),p}for(var u=JSON.parse(JSON.stringify(this.points));u.length>1;){for(var f=0;f<u.length-1;f++)u[f]={x:u[f].x+(u[f+1].x-u[f].x)*t,y:u[f].y+(u[f+1].y-u[f].y)*t},void 0!==u[f].z&&(u[f]=u[f].z+(u[f+1].z-u[f].z)*t);u.splice(u.length-1,1)}return u[0]},raise:function(){for(var t,i,r=this.points,e=[r[0]],n=r.length,o=1;o<n;o++)t=r[o],i=r[o-1],e[o]={x:(n-o)/n*t.x+o/n*i.x,y:(n-o)/n*t.y+o/n*i.y};return e[n]=r[n-1],new d(e)},derivative:function(t){var i,r,e=1-t,n=0,o=this.dpoints[0];2===this.order&&(o=[o[0],o[1],y],i=e,r=t),3===this.order&&(i=e*e,r=e*t*2,n=t*t);var s={x:i*o[0].x+r*o[1].x+n*o[2].x,y:i*o[0].y+r*o[1].y+n*o[2].y};return this._3d&&(s.z=i*o[0].z+r*o[1].z+n*o[2].z),s},inflections:function(){return c.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var i=this.derivative(t),r=u(i.x*i.x+i.y*i.y);return{x:-i.y/r,y:i.x/r}},__normal3:function(t){var i=this.derivative(t),r=this.derivative(t+.01),e=u(i.x*i.x+i.y*i.y+i.z*i.z),n=u(r.x*r.x+r.y*r.y+r.z*r.z);i.x/=e,i.y/=e,i.z/=e,r.x/=n,r.y/=n,r.z/=n;var o={x:r.y*i.z-r.z*i.y,y:r.z*i.x-r.x*i.z,z:r.x*i.y-r.y*i.x},s=u(o.x*o.x+o.y*o.y+o.z*o.z);o.x/=s,o.y/=s,o.z/=s;var a=[o.x*o.x,o.x*o.y-o.z,o.x*o.z+o.y,o.x*o.y+o.z,o.y*o.y,o.y*o.z-o.x,o.x*o.z-o.y,o.y*o.z+o.x,o.z*o.z];return{x:a[0]*i.x+a[1]*i.y+a[2]*i.z,y:a[3]*i.x+a[4]*i.y+a[5]*i.z,z:a[6]*i.x+a[7]*i.y+a[8]*i.z}},hull:function(t){var i,r=this.points,e=[],n=[],o=0,s=0,a=0;for(n[o++]=r[0],n[o++]=r[1],n[o++]=r[2],3===this.order&&(n[o++]=r[3]);r.length>1;){for(e=[],s=0,a=r.length-1;s<a;s++)i=c.lerp(t,r[s],r[s+1]),n[o++]=i,e.push(i);r=e}return n},split:function(t,i){if(0===t&&i)return this.split(i).left;if(1===i)return this.split(t).right;var r=this.hull(t),e={left:2===this.order?new d([r[0],r[3],r[5]]):new d([r[0],r[4],r[7],r[9]]),right:2===this.order?new d([r[5],r[4],r[2]]):new d([r[9],r[8],r[6],r[3]]),span:r};return e.left._t1=c.map(0,0,1,this._t1,this._t2),e.left._t2=c.map(t,0,1,this._t1,this._t2),e.right._t1=c.map(t,0,1,this._t1,this._t2),e.right._t2=c.map(1,0,1,this._t1,this._t2),i?(i=c.map(i,t,1,0,1),e.right.split(i).left):e},extrema:function(){var t,i,r=this.dims,e={},n=[];return r.forEach(function(r){i=function(t){return t[r]},t=this.dpoints[0].map(i),e[r]=c.droots(t),3===this.order&&(t=this.dpoints[1].map(i),e[r]=e[r].concat(c.droots(t))),e[r]=e[r].filter(function(t){return t>=0&&t<=1}),n=n.concat(e[r].sort(c.numberSort))}.bind(this)),n=n.sort(c.numberSort).filter(function(t,i){return n.indexOf(t)===i}),e.values=n,e},bbox:function(){var t=this.extrema(),i={};return this.dims.forEach(function(r){i[r]=c.getminmax(this,r,t[r])}.bind(this)),i},overlaps:function(t){var i=this.bbox(),r=t.bbox();return c.bboxoverlap(i,r)},offset:function(t,i){if(void 0!==i){var r=this.get(t),e=this.normal(t),n={c:r,n:e,x:r.x+e.x*i,y:r.y+e.y*i};return this._3d&&(n.z=r.z+e.z*i),n}if(this._linear){var o=this.normal(0),s=this.points.map(function(i){var r={x:i.x+t*o.x,y:i.y+t*o.y};return i.z&&e.z&&(r.z=i.z+t*o.z),r});return[new d(s)]}return this.reduce().map(function(i){return i.scale(t)})},simple:function(){if(3===this.order){var t=c.angle(this.points[0],this.points[3],this.points[1]),r=c.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&r<0||t<0&&r>0)return!1}var e=this.normal(0),n=this.normal(1),o=e.x*n.x+e.y*n.y;return this._3d&&(o+=e.z*n.z),i(h(o))<f/3},reduce:function(){var t,r,e=0,n=0,o=[],s=[],a=this.extrema().values;for(-1===a.indexOf(0)&&(a=[0].concat(a)),-1===a.indexOf(1)&&a.push(1),e=a[0],t=1;t<a.length;t++)n=a[t],(r=this.split(e,n))._t1=e,r._t2=n,o.push(r),e=n;return o.forEach(function(t){for(e=0,n=0;n<=1;)for(n=e+.01;n<=1.01;n+=.01)if(!(r=t.split(e,n)).simple()){if(i(e-(n-=.01))<.01)return[];(r=t.split(e,n))._t1=c.map(e,0,1,t._t1,t._t2),r._t2=c.map(n,0,1,t._t1,t._t2),s.push(r),e=n;break}e<1&&((r=t.split(e,1))._t1=c.map(e,0,1,t._t1,t._t2),r._t2=t._t2,s.push(r))}),s},scale:function(t){var i=this.order,r=!1;if("function"==typeof t&&(r=t),r&&2===i)return this.raise().scale(r);var e=this.clockwise,n=r?r(0):t,o=r?r(1):t,s=[this.offset(0,10),this.offset(1,10)],a=c.lli4(s[0],s[0].c,s[1],s[1].c);if(!a)throw new Error("cannot scale this curve. Try reducing it first.");var h=this.points,p=[];return[0,1].forEach(function(t){var r=p[t*i]=c.copy(h[t*i]);r.x+=(t?o:n)*s[t].n.x,r.y+=(t?o:n)*s[t].n.y}.bind(this)),r?([0,1].forEach(function(n){if(2!==this.order||!n){var o=h[n+1],s={x:o.x-a.x,y:o.y-a.y},f=r?r((n+1)/i):t;r&&!e&&(f=-f);var y=u(s.x*s.x+s.y*s.y);s.x/=y,s.y/=y,p[n+1]={x:o.x+f*s.x,y:o.y+f*s.y}}}.bind(this)),new d(p)):([0,1].forEach(function(t){if(2!==this.order||!t){var r=p[t*i],e=this.derivative(t),n={x:r.x+e.x,y:r.y+e.y};p[t+1]=c.lli4(r,n,a,h[t+1])}}.bind(this)),new d(p))},outline:function(t,i,r,e){i=void 0===i?t:i;var n,o=this.reduce(),s=o.length,a=[],h=[],p=0,u=this.length(),f=void 0!==r&&void 0!==e;function y(t,i,r,e,n){return function(o){var s=e/r,a=(e+n)/r,h=i-t;return c.map(o,0,1,t+s*h,t+a*h)}}o.forEach(function(n){z=n.length(),f?(a.push(n.scale(y(t,r,u,p,z))),h.push(n.scale(y(-i,-e,u,p,z)))):(a.push(n.scale(t)),h.push(n.scale(-i))),p+=z}),h=h.map(function(t){return(n=t.points)[3]?t.points=[n[3],n[2],n[1],n[0]]:t.points=[n[2],n[1],n[0]],t}).reverse();var d=a[0].points[0],v=a[s-1].points[a[s-1].points.length-1],x=h[s-1].points[h[s-1].points.length-1],g=h[0].points[0],m=c.makeline(x,d),w=c.makeline(v,g),b=[m].concat(a).concat([w]).concat(h),z=b.length;return new l(b)},outlineshapes:function(t,i,r){i=i||t;for(var e=this.outline(t,i).curves,n=[],o=1,s=e.length;o<s/2;o++){var a=c.makeshape(e[o],e[s-o],r);a.startcap.virtual=o>1,a.endcap.virtual=o<s/2-1,n.push(a)}return n},intersects:function(t,i){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof d&&(t=t.reduce()),this.curveintersects(this.reduce(),t,i)):this.selfintersects(i)},lineIntersects:function(t){var i=r(t.p1.x,t.p2.x),n=r(t.p1.y,t.p2.y),o=e(t.p1.x,t.p2.x),s=e(t.p1.y,t.p2.y),a=this;return c.roots(this.points,t).filter(function(t){var r=a.get(t);return c.between(r.x,i,o)&&c.between(r.y,n,s)})},selfintersects:function(t){var i,r,e,n,o=this.reduce(),s=o.length-2,a=[];for(i=0;i<s;i++)e=o.slice(i,i+1),n=o.slice(i+2),r=this.curveintersects(e,n,t),a=a.concat(r);return a},curveintersects:function(t,i,r){var e=[];t.forEach(function(t){i.forEach(function(i){t.overlaps(i)&&e.push({left:t,right:i})})});var n=[];return e.forEach(function(t){var i=c.pairiteration(t.left,t.right,r);i.length>0&&(n=n.concat(i))}),n},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,r,e,n){var o=(n-e)/4,s=this.get(e+o),a=this.get(n-o),h=c.dist(t,r),p=c.dist(t,s),u=c.dist(t,a);return i(p-h)+i(u-h)},_iterate:function(t,i){var r,e=0,n=1;do{r=0,n=1;var o,h,p,u,f,y=this.get(e),l=!1,d=!1,v=n,x=1;do{if(d=l,u=p,v=(e+n)/2,o=this.get(v),h=this.get(n),(p=c.getccenter(y,o,h)).interval={start:e,end:n},l=this._error(p,y,e,n)<=t,(f=d&&!l)||(x=n),l){if(n>=1){if(p.interval.end=x=1,u=p,n>1){var g={x:p.x+p.r*s(p.e),y:p.y+p.r*a(p.e)};p.e+=c.angle({x:p.x,y:p.y},g,this.get(1))}break}n+=(n-e)/2}else n=v}while(!f&&r++<100);if(r>=100)break;u=u||p,i.push(u),e=x}while(n<1);return i}},t.exports=d}()}),f=u;function y(t){return t.charAt(0).toUpperCase()+t.slice(1)}function c(t){return"_macro_"+t}function l(t,i,e,n){var o=t.slope(i),s=e.slope(n);if(o===s)return!1;if(t.x===i.x)return new r(t.x,s*t.x+(e.y-s*e.x));if(e.x===n.x)return new r(e.x,o*e.x+(t.y-o*t.x));t.x>i.x&&(t=i.copy()),e.x>n.x&&(e=n.copy());var a=t.y-o*t.x,h=(e.y-s*e.x-a)/(o-s);return new r(h,o*h+a)}function d(t,i,r,e){var n=l(t,i,r,e);if(!n)return!1;var o=t.dist(i),s=r.dist(e),a=t.dist(n)+n.dist(i),h=r.dist(n)+n.dist(e);return Math.round(o)==Math.round(a)&&Math.round(s)==Math.round(h)&&n}function v(t,i,r){var e=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(r))return!0;if(i.sitsOn(r))return!0;var n=r.dx(t)*i.dy(t)-r.dy(t)*i.dx(t);return 0===Math.abs(Math.round(n*e)/e)}function x(t,i,r){if(!v(t,i,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var e=t.dist(i),n=t.dist(r)+r.dist(i);return Math.round(e)==Math.round(n)}function g(t,i,r,e,n){if(t.sitsOn(n))return!0;if(e.sitsOn(n))return!0;var o=new f({x:t.x,y:t.y},{x:i.x,y:i.y},{x:r.x,y:r.y},{x:e.x,y:e.y}).intersects({p1:{x:n.x-1,y:n.y},p2:{x:n.x+1,y:n.y}});return o.length>0&&o.shift()}function m(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?O(t/25.4)+'"':O(t/10)+"cm"}function w(t,i,e,n,o,s){var a=[],h=new f({x:e.x,y:e.y},{x:n.x,y:n.y},{x:o.x,y:o.y},{x:s.x,y:s.y}),p={p1:{x:t.x,y:t.y},p2:{x:i.x,y:i.y}},u=!0,y=!1,c=void 0;try{for(var l,d=h.intersects(p)[Symbol.iterator]();!(u=(l=d.next()).done);u=!0){var v=l.value,x=h.get(v);a.push(new r(x.x,x.y))}}catch(t){y=!0,c=t}finally{try{!u&&d.return&&d.return()}finally{if(y)throw c}}return 0!==a.length&&(1===a.length?a[0]:a)}function b(t,i,e,n,o,s,a,h){var p=[],u=new f({x:t.x,y:t.y},{x:i.x,y:i.y},{x:e.x,y:e.y},{x:n.x,y:n.y}),y=new f({x:o.x,y:o.y},{x:s.x,y:s.y},{x:a.x,y:a.y},{x:h.x,y:h.y}),c=!0,l=!1,d=void 0;try{for(var v,x=u.intersects(y,.005)[Symbol.iterator]();!(c=(v=x.next()).done);c=!0){var g=v.value,m=u.get(g.substr(0,g.indexOf("/")));p.push(new r(m.x,m.y))}}catch(t){l=!0,d=t}finally{try{!c&&x.return&&x.return()}finally{if(l)throw d}}if(0===p.length)return!1;if(1===p.length)return p.shift();var w=[],b=!0,z=!1,S=void 0;try{for(var O,_=p[Symbol.iterator]();!(b=(O=_.next()).done);b=!0){var M=O.value,k=!1,P=!0,R=!1,L=void 0;try{for(var j,I=w[Symbol.iterator]();!(P=(j=I.next()).done);P=!0){var A=j.value;M.sitsRoughlyOn(A)&&(k=!0)}}catch(t){R=!0,L=t}finally{try{!P&&I.return&&I.return()}finally{if(R)throw L}}k||w.push(M)}}catch(t){z=!0,S=t}finally{try{!b&&_.return&&_.return()}finally{if(z)throw S}}return w}function z(t,i,e,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=n.x-e.x,a=n.y-e.y,h=Math.pow(s,2)+Math.pow(a,2),p=2*(s*(e.x-t.x)+a*(e.y-t.y)),u=Math.pow(e.x-t.x,2)+Math.pow(e.y-t.y,2)-Math.pow(i,2),f=Math.pow(p,2)-4*h*u;if(h<=1e-7||f<0)return!1;if(0===f){var y=-1*p/(2*h);return[new r(e.x+y*s,e.y+y*a)]}var c=(-1*p+Math.sqrt(f))/(2*h),l=new r(e.x+c*s,e.y+c*a);c=(-1*p-Math.sqrt(f))/(2*h);var d=new r(e.x+c*s,e.y+c*a);return"x"===o&&l.x<=d.x||"y"===o&&l.y<=d.y?[l,d]:[d,l]}function S(t,i){var e=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,n=1/0,o=1/0,s=void 0;"bottom"===i&&(o=-1/0),"right"===i&&(n=-1/0);for(var a=0;a<e;a++)s=t.get(a/e),("top"===i&&s.y<o||"bottom"===i&&s.y>o||"right"===i&&s.x>n||"left"===i&&s.x<n)&&(n=s.x,o=s.y);return new r(n,o)}function O(t){return Math.round(100*t)/100}function _(t,i){return"stroke: hsl("+330/i*(t-1)+", 100%, 35%);"}var M=Object.freeze({capitalize:y,macroName:c,beamsIntersect:l,linesIntersect:d,pointOnBeam:v,pointOnLine:x,pointOnCurve:g,beamIntersectsX:function(t,i,e){return t.x!==i.x&&l(t,i,new r(e,-10),new r(e,10))},beamIntersectsY:function(t,i,e){return t.y!==i.y&&l(t,i,new r(-10,e),new r(10,e))},units:m,lineIntersectsCurve:w,curvesIntersect:b,circlesIntersect:function(t,i,e,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=t.dx(e),a=t.dy(e),h=t.dist(e);if(h>parseFloat(i)+parseFloat(n))return!1;if(h<parseFloat(n)-parseFloat(i))return!1;if(0===h&&i===n)return!1;var p=(Math.pow(i,2)-Math.pow(n,2)+Math.pow(h,2))/(2*h),u=Math.sqrt(Math.pow(i,2)-Math.pow(p,2)),f=t.x+p*s/h,y=t.y+p*a/h,c=new r(f+u*a/h,y-u*s/h),l=new r(f-u*a/h,y+u*s/h);return"x"===o&&c.x<=l.x||"y"===o&&c.y<=l.y?[c,l]:[l,c]},beamIntersectsCircle:z,lineIntersectsCircle:function(t,i,r,e){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=z(t,i,r,e,n);if(!1===o)return!1;if(1===o.length)return!!x(r,e,o[0])&&o;var s=o[0],a=o[1];return!(!x(r,e,s,5)&&!x(r,e,a,5))&&(x(r,e,s,5)&&x(r,e,a,5)?"x"===n&&s.x<=a.x||"y"===n&&s.y<=a.y?[s,a]:[a,s]:x(r,e,s,5)?[s]:x(r,e,a,5)?[a]:void 0)},curveEdge:S,stretchToScale:function(t){return 1/(1+parseFloat(t))},round:O,sampleStyle:_}),k="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},P=Object.assign||function(t){for(var i=1;i<arguments.length;i++){var r=arguments[i];for(var e in r)Object.prototype.hasOwnProperty.call(r,e)&&(t[e]=r[e])}return t};function R(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new i,this.ops=[]}function L(t,i,r){if(t.x===i.x&&t.y===i.y)return!1;var e=t.angle(i)-90;return(new R).move(t.shift(e,r)).line(i.shift(e,r))}function j(t){return(new R).move(new r(t.points[0].x,t.points[0].y)).curve(new r(t.points[1].x,t.points[1].y),new r(t.points[2].x,t.points[2].y),new r(t.points[3].x,t.points[3].y))}function I(t){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=(new R).move(t[0].ops[0].to),e=void 0,n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=!0,f=!1,y=void 0;try{for(var c,l=p.ops[Symbol.iterator]();!(u=(c=l.next()).done);u=!0){var d=c.value;if("curve"===d.type)r.curve(d.cp1,d.cp2,d.to);else{if("close"===d.type)throw"Cannot join a closed paths with another";e&&!d.to.sitsRoughlyOn(e)&&r.line(d.to)}d.to&&(e=d.to)}}catch(t){f=!0,y=t}finally{try{!u&&l.return&&l.return()}finally{if(f)throw y}}}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return i&&r.close(),r}function A(t,i){for(var e=void 0,n=void 0,o=void 0,s=void 0,a=0,h=0;h<=100;h++){if(o=h/100,n=new r((n=i.get(o)).x,n.y),h>0){if(a+(s=n.dist(e))>t)return n;a+=s}e=n}}function T(t){var i=t.from,e=t.to;return i.x===e.x?i.y<e.y?{topLeft:i,bottomRight:e}:{topLeft:e,bottomRight:i}:i.y===e.y?i.x<e.x?{topLeft:i,bottomRight:e}:{topLeft:e,bottomRight:i}:i.x<e.x?i.y<e.y?{topLeft:i,bottomRight:e}:{topLeft:new r(i.x,e.y),bottomRight:new r(e.x,i.y)}:i.x>e.x?i.y<e.y?{topLeft:new r(e.x,i.y),bottomRight:new r(i.x,e.y)}:{topLeft:new r(e.x,e.y),bottomRight:new r(i.x,i.y)}:void 0}function C(t,i){if(t&&"object"===(void 0===t?"undefined":k(t)))if("number"==typeof t.x)i.push(t);else{var r=!0,e=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(r=(o=s.next()).done);r=!0){var a=o.value;i.push(a)}}catch(t){e=!0,n=t}finally{try{!r&&s.return&&s.return()}finally{if(e)throw n}}}}function E(t,r){return this.def=t,this.anchor=r,this.attributes=new i,this}function N(){return this.attributes=new i,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=M,this.Point=r,this.Path=R,this.Snippet=E,this}R.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},R.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},R.prototype.curve=function(t,i,r){return this.ops.push({type:"curve",cp1:t,cp2:i,to:r}),this},R.prototype.close=function(){return this.ops.push({type:"close"}),this},R.prototype.attr=function(t,i){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,i):this.attributes.add(t,i),this},R.prototype.asPathstring=function(){var t="",i=!0,r=!1,e=void 0;try{for(var n,o=this.ops[Symbol.iterator]();!(i=(n=o.next()).done);i=!0){var s=n.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){r=!0,e=t}finally{try{!i&&o.return&&o.return()}finally{if(r)throw e}}return t},R.prototype.offset=function(t){return function(t,i){var r=[],e=void 0,n=!1;for(var o in t.ops){var s=t.ops[o];if("line"===s.type){var a=L(e,s.to,i);a&&r.push(a)}else if("curve"===s.type){var h=void 0,p=void 0;h=e.sitsRoughlyOn(s.cp1)?(new R).move(e).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,p=s.cp2.sitsRoughlyOn(s.to)?(new R).move(s.to).curve(s.cp2,s.cp1,e).shiftAlong(2):s.cp2;var u=new f({x:e.x,y:e.y},{x:h.x,y:h.y},{x:p.x,y:p.y},{x:s.to.x,y:s.to.y}),y=!0,c=!1,l=void 0;try{for(var d,v=u.offset(i)[Symbol.iterator]();!(y=(d=v.next()).done);y=!0){var x=d.value;r.push(j(x))}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}else"close"===s.type&&(n=!0);s.to&&(e=s.to)}return I(r,n)}(this,t)},R.prototype.length=function(){var t=void 0,i=void 0,r=0;for(var e in this.ops){var n=this.ops[e];"move"===n.type?i=n.to:"line"===n.type?r+=t.dist(n.to):"curve"===n.type?r+=new f({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).length():"close"===n.type&&(r+=t.dist(i)),n.to&&(t=n.to)}return O(r)},R.prototype.start=function(){return this.ops[0].to},R.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},R.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,i=new r(1/0,1/0),e=new r(-1/0,-1/0),n=[];for(var o in this.ops){var s=this.ops[o];if("move"===s.type||"line"===s.type)s.to.x<i.x&&(i.x=s.to.x,n.leftOp=o),s.to.y<i.y&&(i.y=s.to.y,n.topOp=o),s.to.x>e.x&&(e.x=s.to.x,n.rightOp=o),s.to.y>e.y&&(e.y=s.to.y,n.bottomOp=o);else if("curve"===s.type){var a=new f({x:t.x,y:t.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}).bbox();a.x.min<i.x&&(i.x=a.x.min,n.leftOp=o),a.y.min<i.y&&(i.y=a.y.min,n.topOp=o),a.x.max>e.x&&(e.x=a.x.max,n.rightOp=o),a.y.max>e.y&&(e.y=a.y.max,n.bottomOp=o)}s.to&&(t=s.to)}this.topLeft=i,this.bottomRight=e;for(var h=["top","left","bottom","right"],p=0;p<h.length;p++){var u=h[p]+"Op";this[u]=this.ops[n[u]],this[u].from="move"===this[u].type?this[u].to:this.ops[n[u]-1].to}return this},R.prototype.clone=function(){var t=new R;for(var i in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var r=this.ops[i];t.ops[i]={type:r.type},"move"===r.type||"line"===r.type?t.ops[i].to=r.to.clone():"curve"===r.type&&(t.ops[i].to=r.to.clone(),t.ops[i].cp1=r.cp1.clone(),t.ops[i].cp2=r.cp2.clone())}return t},R.prototype.join=function(t){return I([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},R.prototype.shiftAlong=function(t){var i=0,r=void 0;for(var e in this.ops){var n=this.ops[e];if("line"===n.type){var o=n.to.dist(r);if(i+o>t)return r.shiftTowards(n.to,t-i);i+=o}else if("curve"===n.type){var s=new f({x:r.x,y:r.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}),a=s.length();if(i+a>t)return A(t-i,s);i+=a}r=n.to}throw"Ran out of path to shift along"},R.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},R.prototype.bbox=function(){var t,i,e=[],n=void 0;for(var o in this.ops){var s=this.ops[o];"line"===s.type?e.push(T({from:n,to:s.to})):"curve"===s.type&&e.push((t=new f({x:n.x,y:n.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}),void 0,{topLeft:new r((i=t.bbox()).x.min,i.y.min),bottomRight:new r(i.x.max,i.y.max)})),s.to&&(n=s.to)}return function(t){var i=1/0,e=-1/0,n=1/0,o=-1/0,s=!0,a=!1,h=void 0;try{for(var p,u=t[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;f.topLeft.x<i&&(i=f.topLeft.x),f.topLeft.y<n&&(n=f.topLeft.y),f.bottomRight.x>e&&(e=f.bottomRight.x),f.bottomRight.y>o&&(o=f.bottomRight.y)}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return{topLeft:new r(i,n),bottomRight:new r(e,o)}}(e)},R.prototype.reverse=function(){var t=[],i=void 0,r=!1;for(var e in this.ops){var n=this.ops[e];"line"===n.type?n.to.sitsOn(i)||t.push((new R).move(n.to).line(i)):"curve"===n.type?t.push((new R).move(n.to).curve(n.cp2,n.cp1,i)):"close"===n.type&&(r=!0),n.to&&(i=n.to)}var o=(new R).move(i),s=!0,a=!1,h=void 0;try{for(var p,u=t.reverse()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;o.ops.push(f.ops[1])}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return r&&o.close(),o},R.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new r(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new r(this.topLeft.x,this.bottomRight.y);var i,e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return S((i=this[e],new f({x:i.from.x,y:i.from.y},{x:i.cp1.x,y:i.cp1.y},{x:i.cp2.x,y:i.cp2.y},{x:i.to.x,y:i.to.y})),t)}},R.prototype.divide=function(){var t=[],i=void 0,r=void 0;for(var e in this.ops){var n=this.ops[e];"move"===n.type?r=n.to:"line"===n.type?n.to.sitsRoughlyOn(i)||t.push((new R).move(i).line(n.to)):"curve"===n.type?t.push((new R).move(i).curve(n.cp1,n.cp2,n.to)):"close"===n.type&&t.push((new R).move(i).line(r)),n.to&&(i=n.to)}return t},R.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},R.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},R.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],i=arguments[1];if(!1===t)throw"Path.intersects[X-Y] requires an value as parameter";var e=[],n="x"===i?new r(t,-1e5):new r(-1e4,t),o="x"===i?new r(t,1e5):new r(1e5,t),s=!0,a=!1,h=void 0;try{for(var p,u=this.divide()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;"line"===f.ops[1].type?C(d(f.ops[0].to,f.ops[1].to,n,o),e):"curve"===f.ops[1].type&&C(w(n,o,f.ops[0].to,f.ops[1].cp1,f.ops[1].cp2,f.ops[1].to),e)}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return e},R.prototype.intersects=function(t){if(this===t)throw"Calculating intersections between two identical paths is bad idea";var i=[],r=!0,e=!1,n=void 0;try{for(var o,s=this.divide()[Symbol.iterator]();!(r=(o=s.next()).done);r=!0){var a=o.value,h=!0,p=!1,u=void 0;try{for(var f,y=t.divide()[Symbol.iterator]();!(h=(f=y.next()).done);h=!0){var c=f.value;"line"===a.ops[1].type?"line"===c.ops[1].type?C(d(a.ops[0].to,a.ops[1].to,c.ops[0].to,c.ops[1].to),i):"curve"===c.ops[1].type&&C(w(a.ops[0].to,a.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),i):"curve"===a.ops[1].type&&("line"===c.ops[1].type?C(w(c.ops[0].to,c.ops[1].to,a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to),i):"curve"===c.ops[1].type&&C(b(a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),i))}}catch(t){p=!0,u=t}finally{try{!h&&y.return&&y.return()}finally{if(p)throw u}}}}catch(t){e=!0,n=t}finally{try{!r&&s.return&&s.return()}finally{if(e)throw n}}return i},R.prototype.split=function(t){var i=this.divide(),e=!1,n=!1;for(var o in i){var s=i[o];if("line"===s.ops[1].type)x(s.ops[0].to,s.ops[1].to,t)&&((e=i.slice(0,o)).push((new R).move(s.ops[0].to).line(t)),o++,(n=i.slice(o)).unshift((new R).move(t).line(s.ops[1].to)));else if("curve"===s.ops[1].type){var a=g(s.ops[0].to,s.ops[1].cp1,s.ops[1].cp2,s.ops[1].to,t);if(!1!==a){var h=new f({x:s.ops[0].to.x,y:s.ops[0].to.y},{x:s.ops[1].cp1.x,y:s.ops[1].cp1.y},{x:s.ops[1].cp2.x,y:s.ops[1].cp2.y},{x:s.ops[1].to.x,y:s.ops[1].to.y}).split(a);(e=i.slice(0,o)).push((new R).move(new r(h.left.points[0].x,h.left.points[0].y)).curve(new r(h.left.points[1].x,h.left.points[1].y),new r(h.left.points[2].x,h.left.points[2].y),new r(h.left.points[3].x,h.left.points[3].y))),o++,(n=i.slice(o)).unshift((new R).move(new r(h.right.points[0].x,h.right.points[0].y)).curve(new r(h.right.points[1].x,h.right.points[1].y),new r(h.right.points[2].x,h.right.points[2].y),new r(h.right.points[3].x,h.right.points[3].y)))}}}return e&&(e=I(e)),n&&(n=I(n)),[e,n]},R.prototype.trim=function(){var t=this.divide();for(var i in t)for(var e=parseInt(i)+2,n=parseInt(t.length)-1,o=e;o<n;o++){var s=t[i].intersects(t[o]);if(s.length>0){for(var a=s.pop(),h=t.slice(0,i),p=t.slice(parseInt(o)+1),u=new R,y=!0,c=[i,o],l=0;l<c.length;l++){var d=t[c[l]].ops;if("line"===d[1].type)u.line(a);else if("curve"===d[1].type){var v=new f({x:d[0].to.x,y:d[0].to.y},{x:d[1].cp1.x,y:d[1].cp1.y},{x:d[1].cp2.x,y:d[1].cp2.y},{x:d[1].to.x,y:d[1].to.y}),x=g(d[0].to,d[1].cp1,d[1].cp2,d[1].to,a),m=v.split(x),w=void 0;w=y?m.left:m.right,u.curve(new r(w.points[1].x,w.points[1].y),new r(w.points[2].x,w.points[2].y),new r(w.points[3].x,w.points[3].y))}y=!1}var b=void 0;return b=h.length>0?I(h).join(u):u,p.length>0&&(b=b.join(I(p))),b.trim()}}return this},R.prototype.translate=function(t,i){var r=this.clone(),e=!0,n=!1,o=void 0;try{for(var s,a=r.ops[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;"close"!==h.type&&(h.to=h.to.translate(t,i)),"curve"===h.type&&(h.cp1=h.cp1.translate(t,i),h.cp2=h.cp2.translate(t,i))}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}return r},E.prototype.attr=function(t,i){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,i):this.attributes.add(t,i),this},E.prototype.clone=function(){var t=new E(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},N.prototype.macroClosure=function(t){var i=this;return function(t,r){var e=c(t);"function"==typeof i[e]?i[e](r):i.debug("warning","🚨 Macro not found","Macro "+e.substr(7)+" is not registered")}},N.prototype.debugClosure=function(){var t=this;return function(i,r,e,n,o){t.debug(i,r,e,n,o)}},N.prototype.debug=function(t){},N.prototype.getId=function(){return this.freeId+=1,""+this.freeId},N.prototype.unitsClosure=function(t){var i=this;return function(t){return m(t,i.context.settings.units)}},N.prototype.boundary=function(){if(this.topLeft)return this;var t=new r(1/0,1/0),i=new r(-1/0,-1/0);for(var e in this.paths){var n=this.paths[e].boundary();n.render&&(n.topLeft.x<t.x&&(t.x=n.topLeft.x),n.topLeft.y<t.y&&(t.y=n.topLeft.y),n.bottomRight.x>i.x&&(i.x=n.bottomRight.x),n.bottomRight.y>i.y&&(i.y=n.bottomRight.y))}for(var o in this.points){var s=this.points[o],a=s.attributes.get("data-circle");a&&(a=parseFloat(a),s.x-a<t.x&&(t.x=s.x-a),s.y-a<t.y&&(t.y=s.y-a),s.x+a>i.x&&(i.x=s.x+a),s.y+a>i.y&&(i.y=s.y+a))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),i.x===-1/0&&(i.x=0),i.y===-1/0&&(i.y=0);var h=this.context.settings.margin;return this.context.settings.paperless&&h<10&&(h=10),this.topLeft=new r(t.x-h,t.y-h),this.bottomRight=new r(i.x+h,i.y+h),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},N.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},N.prototype.attr=function(t,i){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,i):this.attributes.add(t,i),this},N.prototype.inject=function(t){for(var i=["points","paths","snippets"],r=0;r<i.length;r++){var e=i[r];for(var n in t[e])void 0===this[e][n]&&(this[e][n]=t[e][n].clone())}return this},N.prototype.units=function(t){return m(t,this.context.settings.units)},N.prototype.shorthand=function(){var t=!!this.context.settings.complete,i=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:M,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:i,debug:this.debugClosure()}};var D="0.22.1";function H(t){this.openGroups=[],this.freeId=0,this.body="",this.style="",this.script="",this.header="",this.footer="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new i,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",D)}H.prototype.runHooks=function(t){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===i&&(i=this);var r=this.hooks[t];if(r.length>0){var e=!0,n=!1,o=void 0;try{for(var s,a=r[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;h.method(i,h.data)}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}}},H.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var i=!0,r=!1,e=void 0;try{for(var n,o=this.hooks.insertText[Symbol.iterator]();!(i=(n=o.next()).done);i=!0){var s=n.value;t=s.method(t,s.data)}}catch(t){r=!0,e=t}finally{try{!i&&o.return&&o.return()}finally{if(r)throw e}}}return t},H.prototype.debug=function(){},H.prototype.render=function(t){for(var i in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.svg=this.prefix,this.svg+=this.renderComments(this.header),this.svg+=this.renderSvgTag(t),this.svg+=this.renderStyle(),this.svg+=this.renderScript(),this.svg+=this.renderDefs(),this.svg+=this.openGroup(this.idPrefix+"container"),t.parts){var r=t.parts[i];r.render&&t.needs(i)&&(this.svg+=this.openGroup(this.idPrefix+"part-"+i,r.attributes),this.svg+=this.renderPart(r),this.svg+=this.closeGroup())}return this.svg+=this.closeGroup(),this.svg+=this.nl()+"</svg>",this.svg+=this.renderComments(this.footer),this.runHooks("postRender"),this.svg},H.prototype.renderSvgTag=function(t){var i="<svg";return this.indent(),i+=this.nl()+this.attributes.render(),this.outdent(),i+=this.nl()+">"+this.nl()},H.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},H.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},H.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},H.prototype.renderComments=function(t){return this.nl()+this.nl()+"\x3c!--"+this.nl()+t+this.nl()+"--\x3e"},H.prototype.renderPart=function(t){var i="";for(var r in t.paths){var e=t.paths[r];e.render&&(i+=this.renderPath(e))}for(var n in t.points)t.points[n].attributes.get("data-text")&&(i+=this.renderText(t.points[n])),t.points[n].attributes.get("data-circle")&&(i+=this.renderCircle(t.points[n]));for(var o in t.snippets){var s=t.snippets[o];i+=this.renderSnippet(s,t)}return i},H.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},H.prototype.renderPathText=function(t){var i=t.attributes.get("data-text");if(!i)return"";this.text=this.insertText(i);var r=t.attributes.renderIfPrefixIs("data-text-"),e="",n=t.attributes.get("data-text-class");n&&n.indexOf("center")>-1?e=' startOffset="50%" ':n&&n.indexOf("right")>-1&&(e=' startOffset="100%" ');var o=this.nl()+"<text>";return this.indent(),o+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+e+"><tspan "+r+">"+this.text+"</tspan></textPath>",this.outdent(),o+=this.nl()+"</text>"},H.prototype.renderText=function(t){var i=t.attributes.getAsArray("data-text");if(!1!==i){var r="",e=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;this.text=this.insertText(h),r+=this.text+" "}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}this.text=this.insertText(r)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var p=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var f=this.text.split("\n");u+="<tspan>"+f.shift()+"</tspan>";var y=!0,c=!1,l=void 0;try{for(var d,v=f[Symbol.iterator]();!(y=(d=v.next()).done);y=!0){var x=d.value;u+='<tspan x="'+t.x+'" dy="'+p+'">'+x+"</tspan>"}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},H.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},H.prototype.renderSnippet=function(t,i){var r=t.anchor.x,e=t.anchor.y,n=t.attributes.get("data-scale");n&&(t.attributes.add("transform","translate("+r+", "+e+")"),t.attributes.add("transform","scale("+n+")"),t.attributes.add("transform","translate("+-1*r+", "+-1*e+")"));var o=t.attributes.get("data-rotate");o&&t.attributes.add("transform","rotate("+o+", "+r+", "+e+")");var s=this.nl();return s+='<use x="'+r+'" y="'+e+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},H.prototype.openGroup=function(t){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=this.nl()+this.nl();return r+="\x3c!-- Start of group #"+t+" --\x3e",r+=this.nl(),r+='<g id="'+t+'"',i&&(r+=" "+i.render()),r+=">",this.indent(),this.openGroups.push(t),r},H.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},H.prototype.nl=function(){return"\n"+this.tab()},H.prototype.tab=function(){for(var t="",i=0;i<this.tabs;i++)t+="  ";return t},H.prototype.indent=function(){this.tabs+=1},H.prototype.outdent=function(){this.tabs-=1},H.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var F=function(){};F.prototype={fit:function(t){var i,r,e,n,o=t.length,s=o>0?t[0].width:0,a=o>0?t[0].height:0;for(this.root={x:0,y:0,width:s,height:a},i=0;i<o;i++)e=t[i],(r=this.findNode(this.root,e.width,e.height))?(n=this.splitNode(r,e.width,e.height),e.x=n.x,e.y=n.y):(n=this.growNode(e.width,e.height),e.x=n.x,e.y=n.y)},findNode:function(t,i,r){return t.used?this.findNode(t.right,i,r)||this.findNode(t.down,i,r):i<=t.width&&r<=t.height?t:null},splitNode:function(t,i,r){return t.used=!0,t.down={x:t.x,y:t.y+r,width:t.width,height:t.height-r},t.right={x:t.x+i,y:t.y,width:t.width-i,height:r},t},growNode:function(t,i){var r=t<=this.root.width,e=i<=this.root.height,n=e&&this.root.height>=this.root.width+t,o=r&&this.root.width>=this.root.height+i;return n?this.growRight(t,i):o?this.growDown(t,i):e?this.growRight(t,i):r?this.growDown(t,i):null},growRight:function(t,i){var r;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(r=this.findNode(this.root,t,i))?this.splitNode(r,t,i):null},growDown:function(t,i){var r;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+i,down:{x:0,y:this.root.height,width:this.root.width,height:i},right:this.root},(r=this.findNode(this.root,t,i))?this.splitNode(r,t,i):null}};var G=F;function q(){this.data=new Map}q.prototype.set=function(t,i){this.data.set(t,i)},q.prototype.setIfUnset=function(t,i){this.data.has(t)||this.data.set(t,i)},q.prototype.get=function(t){return this.data.get(t)};var U={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function B(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];for(var i in this.config=t||{},this.width=!1,this.height=!1,this.is="",this.store=new q,this.parts={},this.hooks=U,this.Part=N,this.Point=r,this.Path=R,this.Snippet=E,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies),t.options){var e=t.options[i];if("object"===(void 0===e?"undefined":k(e)))if(void 0!==e.pct)this.settings.options[i]=e.pct/100;else if(void 0!==e.mm)this.settings.options[i]=e.mm;else if(void 0!==e.deg)this.settings.options[i]=e.deg;else if(void 0!==e.count)this.settings.options[i]=e.count;else{if(void 0===e.dflt)throw"Unknown option type";this.settings.options[i]=e.dflt}else this.settings.options[i]=e}this.context={parts:this.parts,config:this.config,settings:this.settings,store:this.store}}return B.prototype.createPart=function(){var t=new N;return t.context=this.context,t},B.prototype.mergeSettings=function(t){var i=!0,r=!1,e=void 0;try{for(var n,o=Object.keys(t)[Symbol.iterator]();!(i=(n=o.next()).done);i=!0){var s=n.value;"object"===k(t[s])?this.settings[s]=P({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){r=!0,e=t}finally{try{!i&&o.return&&o.return()}finally{if(r)throw e}}},B.prototype.runHooks=function(t){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===i&&(i=this);var r=this.hooks[t];if(r.length>0){var e=!0,n=!1,o=void 0;try{for(var s,a=r[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;h.method(i,h.data)}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}}},B.prototype.draft=function(){this.is="draft",this.runHooks("preDraft");var t=!0,i=!1,r=void 0;try{for(var e,n=this.config.draftOrder[Symbol.iterator]();!(t=(e=n.next()).done);t=!0){var o=e.value,s=this.createPart();if("string"==typeof this.config.inject[o]&&s.inject(this.parts[this.config.inject[o]]),this.needs(o)){var a="draft"+y(o);if("function"!=typeof this[a])throw new Error('Method "'+a+'" on pattern object is not callable');this.parts[o]=this[a](s),this.parts[o].render=this.wants(o)}}}catch(t){i=!0,r=t}finally{try{!t&&n.return&&n.return()}finally{if(i)throw r}}return this.runHooks("postDraft"),this},B.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},B.prototype.sampleParts=function(){var t={};for(var i in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[i]=this.createPart(),t[i].render=this.parts[i].render;return t},B.prototype.sampleRun=function(t,i,r,e){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var o in this.draft(),this.parts){var s=0,a=0;for(var h in this.parts[o].points.anchor&&(void 0===i[o]?i[o]=this.parts[o].points.anchor:i[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(i[o]),a=this.parts[o].points.anchor.dy(i[o]))),this.parts[o].paths)t[o].paths[h+"_"+r]=this.parts[o].paths[h].clone().attr("style",_(r,e)),this.parts[o].points.anchor&&(t[o].paths[h+"_"+r]=t[o].paths[h+"_"+r].translate(s,a)),!1!==n&&t[o].paths[h+"_"+r].attributes.add("class",n)}},B.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var i,r=void 0,e=1,n={},o=this.sampleParts(),s=this.config.options[t];if("object"===k(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(e=100),r=s.min/e,i=(s.max/e-r)/9;for(var a=1;a<11;a++)this.settings.options[t]=r,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+O(r)),this.sampleRun(o,n,a,10),r+=i;return this.parts=o,this.runHooks("postSample"),this},B.prototype.sampleListOption=function(t){var i=this.sampleParts(),r=this.config.options[t],e={},n=1,o=r.list.length,s=!0,a=!1,h=void 0;try{for(var p,u=r.list[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;this.settings.options[t]=f,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+O(f)),this.sampleRun(i,e,n,o),n++}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return this.parts=i,this},B.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var i={},r=this.sampleParts(),e=this.settings.measurements[t];if(void 0===e)throw"Cannot sample a measurement that is undefined";var n=e/50;e*=.9;for(var o=1;o<11;o++)this.settings.measurements[t]=e,this.debug("info","🏃🏿‍♀️ Sample run","Sampling measurement "+t+" with value "+O(e)),this.sampleRun(r,i,o,10),e+=n;return this.parts=r,this.runHooks("postSample"),this},B.prototype.sampleModels=function(t){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var r={},e=this.sampleParts(),n=0,o=Object.keys(t).length;for(var s in t){n++,this.settings.measurements=t[s],this.debug("info","🏃🏿‍♀️ Sample run","Sampling model "+s);var a=s===i?"sample-focus":"";this.sampleRun(e,r,n,o,a)}return this.parts=e,this.runHooks("postSample"),this},B.prototype.debug=function(){for(var t=arguments.length,i=Array(t),r=0;r<t;r++)i[r]=arguments[r];this.runHooks("debug",i)},B.prototype.render=function(){return this.svg=new H(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},B.prototype.on=function(t,i,r){this.hooks[t].push({method:i,data:r})},B.prototype.with=function(t){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug("success","🔌 Plugin loaded",t.name+" v"+t.version),t.hooks&&this.loadPluginHooks(t,i),t.macros&&this.loadPluginMacros(t),this},B.prototype.loadPluginHooks=function(t,i){var r=!0,e=!1,n=void 0;try{for(var o,s=Object.keys(this.hooks)[Symbol.iterator]();!(r=(o=s.next()).done);r=!0){var a=o.value;if("function"==typeof t.hooks[a])this.on(a,t.hooks[a],i);else if("object"===k(t.hooks[a])){var h=!0,p=!1,u=void 0;try{for(var f,y=t.hooks[a][Symbol.iterator]();!(h=(f=y.next()).done);h=!0){var c=f.value;this.on(a,c,i)}}catch(t){p=!0,u=t}finally{try{!h&&y.return&&y.return()}finally{if(p)throw u}}}}}catch(t){e=!0,n=t}finally{try{!r&&s.return&&s.return()}finally{if(e)throw n}}},B.prototype.loadPluginMacros=function(t){for(var i in t.macros)"function"==typeof t.macros[i]&&this.macro(i,t.macros[i])},B.prototype.macro=function(t,i){this.Part.prototype[c(t)]=i},B.prototype.pack=function(){var t=[];for(var i in this.parts){var r=this.parts[i];r.attributes.set("transform",""),r.render&&this.needs(i)&&(r.stack(),t.push({id:i,width:r.bottomRight.x-r.topLeft.x,height:r.bottomRight.y-r.topLeft.y}))}var e=function(t,i){i=i||{};var r=new G,e=i.inPlace||!1,n=t.map(function(t){return e?t:{width:t.width,height:t.height,item:t}});n=n.sort(function(t,i){return i.width*i.height-t.width*t.height}),r.fit(n);var o={width:n.reduce(function(t,i){return Math.max(t,i.x+i.width)},0),height:n.reduce(function(t,i){return Math.max(t,i.y+i.height)},0)};return e||(o.items=n),o}(t,{inPlace:!0}),n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=this.parts[p.id];0===p.x&&0===p.y||u.attr("transform","translate ("+p.x+", "+p.y+")")}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return this.width=e.width,this.height=e.height,this},B.prototype.draftOrder=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.resolveDependencies(),i=[],r={};return Object.keys(t).forEach(function e(n,o){Array.isArray(o)||(o=[]),o.push(n),r[n]=!0,void 0!==t[n]&&t[n].forEach(function(t){if(o.indexOf(t)>=0)throw new Error('Circular dependency "'+t+'" is required by "'+n+'": '+o.join(" -> "));r[t]||e(t,o.slice(0))}),i.indexOf(n)<0&&i.push(n)}),i},B.prototype.resolveDependency=function(t,i){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.config.dependencies,e=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];return void 0===t[i]&&(t[i]=!0),"string"==typeof r[i]?(e.push(r[i]),this.resolveDependency(t,r[i],r,e)):e},B.prototype.resolveDependencies=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.config.dependencies,i={},r={},e=!0,n=!1,o=void 0;try{for(var s,a=Object.keys(t)[Symbol.iterator]();!(e=(s=a.next()).done);e=!0){var h=s.value;i[h]=this.resolveDependency(r,h,t)}}catch(t){n=!0,o=t}finally{try{!e&&a.return&&a.return()}finally{if(n)throw o}}var p=!0,u=!1,f=void 0;try{for(var y,c=Object.keys(r)[Symbol.iterator]();!(p=(y=c.next()).done);p=!0){var l=y.value;void 0===i[l]&&(i[l]=[])}}catch(t){u=!0,f=t}finally{try{!p&&c.return&&c.return()}finally{if(u)throw f}}return i},B.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only])){var i=!0,r=!1,e=void 0;try{for(var n,o=this.config.resolvedDependencies[this.settings.only][Symbol.iterator]();!(i=(n=o.next()).done);i=!0){if(n.value===t)return!0}}catch(t){r=!0,e=t}finally{try{!i&&o.return&&o.return()}finally{if(r)throw e}}}}else if(Array.isArray(this.settings.only)){var s=!0,a=!1,h=void 0;try{for(var p,u=this.settings.only[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;if(f===t)return!0;var y=!0,c=!1,l=void 0;try{for(var d,v=this.config.resolvedDependencies[f][Symbol.iterator]();!(y=(d=v.next()).done);y=!0){if(d.value===t)return!0}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}}return!1},B.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},B.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){var i=!0,r=!1,e=void 0;try{for(var n,o=this.settings.only[Symbol.iterator]();!(i=(n=o.next()).done);i=!0){if(n.value===t)return!0}}catch(t){r=!0,e=t}finally{try{!i&&o.return&&o.return()}finally{if(r)throw e}}return!1}}return!0},{version:D,Pattern:B,Point:r,Path:R,Snippet:E,utils:M,patterns:{},plugins:{}}}(crypto);
//# sourceMappingURL=browser.js.map
