/**
 * freesewing | v0.22.1
 * A library for creating made-to-measure sewing patterns
 * (c) 2018 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
"use strict";function _interopDefault(t){return t&&"object"==typeof t&&"default"in t?t.default:t}var Bezier=_interopDefault(require("bezier-js"));require("crypto");var pack=_interopDefault(require("bin-pack"));function Attributes(){this.list={}}function Point(t,e){this.x=round(t),this.y=round(e),this.attributes=new Attributes}function capitalize(t){return t.charAt(0).toUpperCase()+t.slice(1)}function macroName(t){return"_macro_"+t}function beamsIntersect(t,e,i,r){var n=t.slope(e),o=i.slope(r);if(n===o)return!1;if(t.x===e.x)return new Point(t.x,o*t.x+(i.y-o*i.x));if(i.x===r.x)return new Point(i.x,n*i.x+(t.y-n*t.x));t.x>e.x&&(t=e.copy()),i.x>r.x&&(i=r.copy());var s=t.y-n*t.x,a=(i.y-o*i.x-s)/(n-o);return new Point(a,n*a+s)}function linesIntersect(t,e,i,r){var n=beamsIntersect(t,e,i,r);if(!n)return!1;var o=t.dist(e),s=i.dist(r),a=t.dist(n)+n.dist(e),h=i.dist(n)+n.dist(r);return Math.round(o)==Math.round(a)&&Math.round(s)==Math.round(h)&&n}function pointOnBeam(t,e,i){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(i))return!0;if(e.sitsOn(i))return!0;var n=i.dx(t)*e.dy(t)-i.dy(t)*e.dx(t);return 0===Math.abs(Math.round(n*r)/r)}function pointOnLine(t,e,i){if(!pointOnBeam(t,e,i,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var r=t.dist(e),n=t.dist(i)+i.dist(e);return Math.round(r)==Math.round(n)}function pointOnCurve(t,e,i,r,n){if(t.sitsOn(n))return!0;if(r.sitsOn(n))return!0;var o=new Bezier({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:r.x,y:r.y}).intersects({p1:{x:n.x-1,y:n.y},p2:{x:n.x+1,y:n.y}});return o.length>0&&o.shift()}function beamIntersectsX(t,e,i){return t.x!==e.x&&beamsIntersect(t,e,new Point(i,-10),new Point(i,10))}function beamIntersectsY(t,e,i){return t.y!==e.y&&beamsIntersect(t,e,new Point(-10,i),new Point(10,i))}function units(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?round(t/25.4)+'"':round(t/10)+"cm"}function lineIntersectsCurve(t,e,i,r,n,o){var s=[],a=new Bezier({x:i.x,y:i.y},{x:r.x,y:r.y},{x:n.x,y:n.y},{x:o.x,y:o.y}),h={p1:{x:t.x,y:t.y},p2:{x:e.x,y:e.y}},p=!0,u=!1,y=void 0;try{for(var f,l=a.intersects(h)[Symbol.iterator]();!(p=(f=l.next()).done);p=!0){var c=f.value,v=a.get(c);s.push(new Point(v.x,v.y))}}catch(t){u=!0,y=t}finally{try{!p&&l.return&&l.return()}finally{if(u)throw y}}return 0!==s.length&&(1===s.length?s[0]:s)}function curvesIntersect(t,e,i,r,n,o,s,a){var h=[],p=new Bezier({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:r.x,y:r.y}),u=new Bezier({x:n.x,y:n.y},{x:o.x,y:o.y},{x:s.x,y:s.y},{x:a.x,y:a.y}),y=!0,f=!1,l=void 0;try{for(var c,v=p.intersects(u,.005)[Symbol.iterator]();!(y=(c=v.next()).done);y=!0){var d=c.value,x=p.get(d.substr(0,d.indexOf("/")));h.push(new Point(x.x,x.y))}}catch(t){f=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(f)throw l}}if(0===h.length)return!1;if(1===h.length)return h.shift();var g=[],m=!0,b=!1,P=void 0;try{for(var w,S=h[Symbol.iterator]();!(m=(w=S.next()).done);m=!0){var O=w.value,I=!1,L=!0,A=!1,k=void 0;try{for(var R,M=g[Symbol.iterator]();!(L=(R=M.next()).done);L=!0){var j=R.value;O.sitsRoughlyOn(j)&&(I=!0)}}catch(t){A=!0,k=t}finally{try{!L&&M.return&&M.return()}finally{if(A)throw k}}I||g.push(O)}}catch(t){b=!0,P=t}finally{try{!m&&S.return&&S.return()}finally{if(b)throw P}}return g}function circlesIntersect(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=t.dx(i),s=t.dy(i),a=t.dist(i);if(a>parseFloat(e)+parseFloat(r))return!1;if(a<parseFloat(r)-parseFloat(e))return!1;if(0===a&&e===r)return!1;var h=(Math.pow(e,2)-Math.pow(r,2)+Math.pow(a,2))/(2*a),p=Math.sqrt(Math.pow(e,2)-Math.pow(h,2)),u=t.x+h*o/a,y=t.y+h*s/a,f=new Point(u+p*s/a,y-p*o/a),l=new Point(u-p*s/a,y+p*o/a);return"x"===n&&f.x<=l.x||"y"===n&&f.y<=l.y?[f,l]:[l,f]}function beamIntersectsCircle(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=r.x-i.x,s=r.y-i.y,a=Math.pow(o,2)+Math.pow(s,2),h=2*(o*(i.x-t.x)+s*(i.y-t.y)),p=Math.pow(i.x-t.x,2)+Math.pow(i.y-t.y,2)-Math.pow(e,2),u=Math.pow(h,2)-4*a*p;if(a<=1e-7||u<0)return!1;if(0===u){var y=-1*h/(2*a);return[new Point(i.x+y*o,i.y+y*s)]}var f=(-1*h+Math.sqrt(u))/(2*a),l=new Point(i.x+f*o,i.y+f*s);f=(-1*h-Math.sqrt(u))/(2*a);var c=new Point(i.x+f*o,i.y+f*s);return"x"===n&&l.x<=c.x||"y"===n&&l.y<=c.y?[l,c]:[c,l]}function lineIntersectsCircle(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=beamIntersectsCircle(t,e,i,r,n);if(!1===o)return!1;if(1===o.length)return!!pointOnLine(i,r,o[0])&&o;var s=o[0],a=o[1];return!(!pointOnLine(i,r,s,5)&&!pointOnLine(i,r,a,5))&&(pointOnLine(i,r,s,5)&&pointOnLine(i,r,a,5)?"x"===n&&s.x<=a.x||"y"===n&&s.y<=a.y?[s,a]:[a,s]:pointOnLine(i,r,s,5)?[s]:pointOnLine(i,r,a,5)?[a]:void 0)}function curveEdge(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,r=1/0,n=1/0,o=void 0;"bottom"===e&&(n=-1/0),"right"===e&&(r=-1/0);for(var s=0;s<i;s++)o=t.get(s/i),("top"===e&&o.y<n||"bottom"===e&&o.y>n||"right"===e&&o.x>r||"left"===e&&o.x<r)&&(r=o.x,n=o.y);return new Point(r,n)}function stretchToScale(t){return 1/(1+parseFloat(t))}function round(t){return Math.round(100*t)/100}function sampleStyle(t,e){return"stroke: hsl("+330/e*(t-1)+", 100%, 35%);"}Attributes.prototype.add=function(t,e){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(e),this},Attributes.prototype.set=function(t,e){return this.list[t]=[e],this},Attributes.prototype.remove=function(t){return delete this.list[t],this},Attributes.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},Attributes.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},Attributes.prototype.render=function(){var t="";for(var e in this.list)t+=" "+e+'="'+this.list[e].join(" ")+'"';return t},Attributes.prototype.renderAsCss=function(){var t="";for(var e in this.list)t+=" "+e+":"+this.list[e].join(" ")+";";return t},Attributes.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",e="",i=t.length;for(var r in this.list)r.substr(0,i)===t&&(e+=" "+r.substr(i)+'="'+this.list[r].join(" ")+'"');return e},Attributes.prototype.clone=function(){var t=new Attributes;return t.list=JSON.parse(JSON.stringify(this.list)),t},Point.prototype.rad2deg=function(t){return 57.29577951308232*t},Point.prototype.deg2rad=function(t){return t/57.29577951308232},Point.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Point.prototype.dist=function(t){var e=this.x-t.x,i=this.y-t.y;return round(Math.sqrt(Math.pow(e,2)+Math.pow(i,2)))},Point.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},Point.prototype.dx=function(t){return t.x-this.x},Point.prototype.dy=function(t){return t.y-this.y},Point.prototype.angle=function(t){for(var e=Math.atan2(-1*this.dy(t),this.dx(t));e<0;)e+=2*Math.PI;return this.rad2deg(e)},Point.prototype.rotate=function(t,e){var i=this.dist(e),r=this.angle(e);return new Point(e.x+i*Math.cos(this.deg2rad(r+t))*-1,e.y+i*Math.sin(this.deg2rad(r+t)))},Point.prototype.copy=function(){return new Point(this.x,this.y)},Point.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(!1===t?-1*this.x:t.x+this.dx(t),this.y)},Point.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(this.x,!1===t?-1*this.y:t.y+this.dy(t))},Point.prototype.shift=function(t,e){var i=this.copy();return i.x+=e,i.rotate(t,this)},Point.prototype.shiftTowards=function(t,e){return this.shift(this.angle(t),e)},Point.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},Point.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},Point.prototype.shiftFractionTowards=function(t,e){return this.shiftTowards(t,this.dist(t)*e)},Point.prototype.shiftOutwards=function(t,e){return this.shiftTowards(t,this.dist(t)+e)},Point.prototype.clone=function(){var t=new Point(this.x,this.y);return t.attributes=this.attributes.clone(),t},Point.prototype.translate=function(t,e){var i=this.copy();return i.x+=t,i.y+=e,i};var utils=Object.freeze({capitalize:capitalize,macroName:macroName,beamsIntersect:beamsIntersect,linesIntersect:linesIntersect,pointOnBeam:pointOnBeam,pointOnLine:pointOnLine,pointOnCurve:pointOnCurve,beamIntersectsX:beamIntersectsX,beamIntersectsY:beamIntersectsY,units:units,lineIntersectsCurve:lineIntersectsCurve,curvesIntersect:curvesIntersect,circlesIntersect:circlesIntersect,beamIntersectsCircle:beamIntersectsCircle,lineIntersectsCircle:lineIntersectsCircle,curveEdge:curveEdge,stretchToScale:stretchToScale,round:round,sampleStyle:sampleStyle}),_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},_extends=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var r in i)Object.prototype.hasOwnProperty.call(i,r)&&(t[r]=i[r])}return t};function Path(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new Attributes,this.ops=[]}function pathOffset(t,e){var i=[],r=void 0,n=!1;for(var o in t.ops){var s=t.ops[o];if("line"===s.type){var a=offsetLine(r,s.to,e);a&&i.push(a)}else if("curve"===s.type){var h=void 0,p=void 0;h=r.sitsRoughlyOn(s.cp1)?(new Path).move(r).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,p=s.cp2.sitsRoughlyOn(s.to)?(new Path).move(s.to).curve(s.cp2,s.cp1,r).shiftAlong(2):s.cp2;var u=new Bezier({x:r.x,y:r.y},{x:h.x,y:h.y},{x:p.x,y:p.y},{x:s.to.x,y:s.to.y}),y=!0,f=!1,l=void 0;try{for(var c,v=u.offset(e)[Symbol.iterator]();!(y=(c=v.next()).done);y=!0){var d=c.value;i.push(asPath(d))}}catch(t){f=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(f)throw l}}}else"close"===s.type&&(n=!0);s.to&&(r=s.to)}return joinPaths(i,n)}function offsetLine(t,e,i){if(t.x===e.x&&t.y===e.y)return!1;var r=t.angle(e)-90;return(new Path).move(t.shift(r,i)).line(e.shift(r,i))}function asPath(t){return(new Path).move(new Point(t.points[0].x,t.points[0].y)).curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}function joinPaths(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=(new Path).move(t[0].ops[0].to),r=void 0,n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=!0,y=!1,f=void 0;try{for(var l,c=p.ops[Symbol.iterator]();!(u=(l=c.next()).done);u=!0){var v=l.value;if("curve"===v.type)i.curve(v.cp1,v.cp2,v.to);else{if("close"===v.type)throw"Cannot join a closed paths with another";r&&!v.to.sitsRoughlyOn(r)&&i.line(v.to)}v.to&&(r=v.to)}}catch(t){y=!0,f=t}finally{try{!u&&c.return&&c.return()}finally{if(y)throw f}}}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return e&&i.close(),i}function shiftAlongBezier(t,e){for(var i=void 0,r=void 0,n=void 0,o=void 0,s=0,a=0;a<=100;a++){if(n=a/100,r=new Point((r=e.get(n)).x,r.y),a>0){if(s+(o=r.dist(i))>t)return r;s+=o}i=r}}function lineBoundingBox(t){var e=t.from,i=t.to;return e.x===i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.y===i.y?e.x<i.x?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.x<i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:new Point(e.x,i.y),bottomRight:new Point(i.x,e.y)}:e.x>i.x?e.y<i.y?{topLeft:new Point(i.x,e.y),bottomRight:new Point(e.x,i.y)}:{topLeft:new Point(i.x,i.y),bottomRight:new Point(e.x,e.y)}:void 0}function curveBoundingBox(t){var e=t.bbox();return{topLeft:new Point(e.x.min,e.y.min),bottomRight:new Point(e.x.max,e.y.max)}}function bbbbox(t){var e=1/0,i=-1/0,r=1/0,n=-1/0,o=!0,s=!1,a=void 0;try{for(var h,p=t[Symbol.iterator]();!(o=(h=p.next()).done);o=!0){var u=h.value;u.topLeft.x<e&&(e=u.topLeft.x),u.topLeft.y<r&&(r=u.topLeft.y),u.bottomRight.x>i&&(i=u.bottomRight.x),u.bottomRight.y>n&&(n=u.bottomRight.y)}}catch(t){s=!0,a=t}finally{try{!o&&p.return&&p.return()}finally{if(s)throw a}}return{topLeft:new Point(e,r),bottomRight:new Point(i,n)}}function edgeCurveAsBezier(t){return new Bezier({x:t.from.x,y:t.from.y},{x:t.cp1.x,y:t.cp1.y},{x:t.cp2.x,y:t.cp2.y},{x:t.to.x,y:t.to.y})}function addIntersectionsToArray(t,e){if(t&&"object"===(void 0===t?"undefined":_typeof(t)))if("number"==typeof t.x)e.push(t);else{var i=!0,r=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value;e.push(a)}}catch(t){r=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(r)throw n}}}}function Snippet(t,e){return this.def=t,this.anchor=e,this.attributes=new Attributes,this}function Part(){return this.attributes=new Attributes,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=utils,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this}Path.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},Path.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},Path.prototype.curve=function(t,e,i){return this.ops.push({type:"curve",cp1:t,cp2:e,to:i}),this},Path.prototype.close=function(){return this.ops.push({type:"close"}),this},Path.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Path.prototype.asPathstring=function(){var t="",e=!0,i=!1,r=void 0;try{for(var n,o=this.ops[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}return t},Path.prototype.offset=function(t){return pathOffset(this,t)},Path.prototype.length=function(){var t=void 0,e=void 0,i=0;for(var r in this.ops){var n=this.ops[r];"move"===n.type?e=n.to:"line"===n.type?i+=t.dist(n.to):"curve"===n.type?i+=new Bezier({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).length():"close"===n.type&&(i+=t.dist(e)),n.to&&(t=n.to)}return round(i)},Path.prototype.start=function(){return this.ops[0].to},Path.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},Path.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,e=new Point(1/0,1/0),i=new Point(-1/0,-1/0),r=[];for(var n in this.ops){var o=this.ops[n];if("move"===o.type||"line"===o.type)o.to.x<e.x&&(e.x=o.to.x,r.leftOp=n),o.to.y<e.y&&(e.y=o.to.y,r.topOp=n),o.to.x>i.x&&(i.x=o.to.x,r.rightOp=n),o.to.y>i.y&&(i.y=o.to.y,r.bottomOp=n);else if("curve"===o.type){var s=new Bezier({x:t.x,y:t.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}).bbox();s.x.min<e.x&&(e.x=s.x.min,r.leftOp=n),s.y.min<e.y&&(e.y=s.y.min,r.topOp=n),s.x.max>i.x&&(i.x=s.x.max,r.rightOp=n),s.y.max>i.y&&(i.y=s.y.max,r.bottomOp=n)}o.to&&(t=o.to)}this.topLeft=e,this.bottomRight=i;for(var a=["top","left","bottom","right"],h=0;h<a.length;h++){var p=a[h]+"Op";this[p]=this.ops[r[p]],this[p].from="move"===this[p].type?this[p].to:this.ops[r[p]-1].to}return this},Path.prototype.clone=function(){var t=new Path;for(var e in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var i=this.ops[e];t.ops[e]={type:i.type},"move"===i.type||"line"===i.type?t.ops[e].to=i.to.clone():"curve"===i.type&&(t.ops[e].to=i.to.clone(),t.ops[e].cp1=i.cp1.clone(),t.ops[e].cp2=i.cp2.clone())}return t},Path.prototype.join=function(t){return joinPaths([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},Path.prototype.shiftAlong=function(t){var e=0,i=void 0;for(var r in this.ops){var n=this.ops[r];if("line"===n.type){var o=n.to.dist(i);if(e+o>t)return i.shiftTowards(n.to,t-e);e+=o}else if("curve"===n.type){var s=new Bezier({x:i.x,y:i.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}),a=s.length();if(e+a>t)return shiftAlongBezier(t-e,s);e+=a}i=n.to}throw"Ran out of path to shift along"},Path.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},Path.prototype.bbox=function(){var t=[],e=void 0;for(var i in this.ops){var r=this.ops[i];"line"===r.type?t.push(lineBoundingBox({from:e,to:r.to})):"curve"===r.type&&t.push(curveBoundingBox(new Bezier({x:e.x,y:e.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y}))),r.to&&(e=r.to)}return bbbbox(t)},Path.prototype.reverse=function(){var t=[],e=void 0,i=!1;for(var r in this.ops){var n=this.ops[r];"line"===n.type?n.to.sitsOn(e)||t.push((new Path).move(n.to).line(e)):"curve"===n.type?t.push((new Path).move(n.to).curve(n.cp2,n.cp1,e)):"close"===n.type&&(i=!0),n.to&&(e=n.to)}var o=(new Path).move(e),s=!0,a=!1,h=void 0;try{for(var p,u=t.reverse()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var y=p.value;o.ops.push(y.ops[1])}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return i&&o.close(),o},Path.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new Point(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new Point(this.topLeft.x,this.bottomRight.y);var e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return curveEdge(edgeCurveAsBezier(this[e]),t)}},Path.prototype.divide=function(){var t=[],e=void 0,i=void 0;for(var r in this.ops){var n=this.ops[r];"move"===n.type?i=n.to:"line"===n.type?n.to.sitsRoughlyOn(e)||t.push((new Path).move(e).line(n.to)):"curve"===n.type?t.push((new Path).move(e).curve(n.cp1,n.cp2,n.to)):"close"===n.type&&t.push((new Path).move(e).line(i)),n.to&&(e=n.to)}return t},Path.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},Path.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},Path.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],e=arguments[1];if(!1===t)throw"Path.intersects[X-Y] requires an value as parameter";var i=[],r="x"===e?new Point(t,-1e5):new Point(-1e4,t),n="x"===e?new Point(t,1e5):new Point(1e5,t),o=!0,s=!1,a=void 0;try{for(var h,p=this.divide()[Symbol.iterator]();!(o=(h=p.next()).done);o=!0){var u=h.value;"line"===u.ops[1].type?addIntersectionsToArray(linesIntersect(u.ops[0].to,u.ops[1].to,r,n),i):"curve"===u.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(r,n,u.ops[0].to,u.ops[1].cp1,u.ops[1].cp2,u.ops[1].to),i)}}catch(t){s=!0,a=t}finally{try{!o&&p.return&&p.return()}finally{if(s)throw a}}return i},Path.prototype.intersects=function(t){if(this===t)throw"Calculating intersections between two identical paths is bad idea";var e=[],i=!0,r=!1,n=void 0;try{for(var o,s=this.divide()[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value,h=!0,p=!1,u=void 0;try{for(var y,f=t.divide()[Symbol.iterator]();!(h=(y=f.next()).done);h=!0){var l=y.value;"line"===a.ops[1].type?"line"===l.ops[1].type?addIntersectionsToArray(linesIntersect(a.ops[0].to,a.ops[1].to,l.ops[0].to,l.ops[1].to),e):"curve"===l.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(a.ops[0].to,a.ops[1].to,l.ops[0].to,l.ops[1].cp1,l.ops[1].cp2,l.ops[1].to),e):"curve"===a.ops[1].type&&("line"===l.ops[1].type?addIntersectionsToArray(lineIntersectsCurve(l.ops[0].to,l.ops[1].to,a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to),e):"curve"===l.ops[1].type&&addIntersectionsToArray(curvesIntersect(a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to,l.ops[0].to,l.ops[1].cp1,l.ops[1].cp2,l.ops[1].to),e))}}catch(t){p=!0,u=t}finally{try{!h&&f.return&&f.return()}finally{if(p)throw u}}}}catch(t){r=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(r)throw n}}return e},Path.prototype.split=function(t){var e=this.divide(),i=!1,r=!1;for(var n in e){var o=e[n];if("line"===o.ops[1].type)pointOnLine(o.ops[0].to,o.ops[1].to,t)&&((i=e.slice(0,n)).push((new Path).move(o.ops[0].to).line(t)),n++,(r=e.slice(n)).unshift((new Path).move(t).line(o.ops[1].to)));else if("curve"===o.ops[1].type){var s=pointOnCurve(o.ops[0].to,o.ops[1].cp1,o.ops[1].cp2,o.ops[1].to,t);if(!1!==s){var a=new Bezier({x:o.ops[0].to.x,y:o.ops[0].to.y},{x:o.ops[1].cp1.x,y:o.ops[1].cp1.y},{x:o.ops[1].cp2.x,y:o.ops[1].cp2.y},{x:o.ops[1].to.x,y:o.ops[1].to.y}).split(s);(i=e.slice(0,n)).push((new Path).move(new Point(a.left.points[0].x,a.left.points[0].y)).curve(new Point(a.left.points[1].x,a.left.points[1].y),new Point(a.left.points[2].x,a.left.points[2].y),new Point(a.left.points[3].x,a.left.points[3].y))),n++,(r=e.slice(n)).unshift((new Path).move(new Point(a.right.points[0].x,a.right.points[0].y)).curve(new Point(a.right.points[1].x,a.right.points[1].y),new Point(a.right.points[2].x,a.right.points[2].y),new Point(a.right.points[3].x,a.right.points[3].y)))}}}return i&&(i=joinPaths(i)),r&&(r=joinPaths(r)),[i,r]},Path.prototype.trim=function(){var t=this.divide();for(var e in t)for(var i=parseInt(e)+2,r=parseInt(t.length)-1,n=i;n<r;n++){var o=t[e].intersects(t[n]);if(o.length>0){for(var s=o.pop(),a=t.slice(0,e),h=t.slice(parseInt(n)+1),p=new Path,u=!0,y=[e,n],f=0;f<y.length;f++){var l=t[y[f]].ops;if("line"===l[1].type)p.line(s);else if("curve"===l[1].type){var c=new Bezier({x:l[0].to.x,y:l[0].to.y},{x:l[1].cp1.x,y:l[1].cp1.y},{x:l[1].cp2.x,y:l[1].cp2.y},{x:l[1].to.x,y:l[1].to.y}),v=pointOnCurve(l[0].to,l[1].cp1,l[1].cp2,l[1].to,s),d=c.split(v),x=void 0;x=u?d.left:d.right,p.curve(new Point(x.points[1].x,x.points[1].y),new Point(x.points[2].x,x.points[2].y),new Point(x.points[3].x,x.points[3].y))}u=!1}var g=void 0;return g=a.length>0?joinPaths(a).join(p):p,h.length>0&&(g=g.join(joinPaths(h))),g.trim()}}return this},Path.prototype.translate=function(t,e){var i=this.clone(),r=!0,n=!1,o=void 0;try{for(var s,a=i.ops[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;"close"!==h.type&&(h.to=h.to.translate(t,e)),"curve"===h.type&&(h.cp1=h.cp1.translate(t,e),h.cp2=h.cp2.translate(t,e))}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}return i},Snippet.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Snippet.prototype.clone=function(){var t=new Snippet(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},Part.prototype.macroClosure=function(t){var e=this;return function(t,i){var r=macroName(t);"function"==typeof e[r]?e[r](i):e.debug("warning","🚨 Macro not found","Macro "+r.substr(7)+" is not registered")}},Part.prototype.debugClosure=function(){var t=this;return function(e,i,r,n,o){t.debug(e,i,r,n,o)}},Part.prototype.debug=function(t){},Part.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Part.prototype.unitsClosure=function(t){var e=this;return function(t){return units(t,e.context.settings.units)}},Part.prototype.boundary=function(){if(this.topLeft)return this;var t=new Point(1/0,1/0),e=new Point(-1/0,-1/0);for(var i in this.paths){var r=this.paths[i].boundary();r.render&&(r.topLeft.x<t.x&&(t.x=r.topLeft.x),r.topLeft.y<t.y&&(t.y=r.topLeft.y),r.bottomRight.x>e.x&&(e.x=r.bottomRight.x),r.bottomRight.y>e.y&&(e.y=r.bottomRight.y))}for(var n in this.points){var o=this.points[n],s=o.attributes.get("data-circle");s&&(s=parseFloat(s),o.x-s<t.x&&(t.x=o.x-s),o.y-s<t.y&&(t.y=o.y-s),o.x+s>e.x&&(e.x=o.x+s),o.y+s>e.y&&(e.y=o.y+s))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),e.x===-1/0&&(e.x=0),e.y===-1/0&&(e.y=0);var a=this.context.settings.margin;return this.context.settings.paperless&&a<10&&(a=10),this.topLeft=new Point(t.x-a,t.y-a),this.bottomRight=new Point(e.x+a,e.y+a),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},Part.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},Part.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Part.prototype.inject=function(t){for(var e=["points","paths","snippets"],i=0;i<e.length;i++){var r=e[i];for(var n in t[r])void 0===this[r][n]&&(this[r][n]=t[r][n].clone())}return this},Part.prototype.units=function(t){return units(t,this.context.settings.units)},Part.prototype.shorthand=function(){var t=!!this.context.settings.complete,e=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:utils,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:e,debug:this.debugClosure()}};var version="0.22.1";function Svg(t){this.openGroups=[],this.freeId=0,this.body="",this.style="",this.script="",this.header="",this.footer="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new Attributes,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",version)}function Store(){this.data=new Map}Svg.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var i=this.hooks[t];if(i.length>0){var r=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;h.method(e,h.data)}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}}},Svg.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var e=!0,i=!1,r=void 0;try{for(var n,o=this.hooks.insertText[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;t=s.method(t,s.data)}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}}return t},Svg.prototype.debug=function(){},Svg.prototype.render=function(t){for(var e in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.svg=this.prefix,this.svg+=this.renderComments(this.header),this.svg+=this.renderSvgTag(t),this.svg+=this.renderStyle(),this.svg+=this.renderScript(),this.svg+=this.renderDefs(),this.svg+=this.openGroup(this.idPrefix+"container"),t.parts){var i=t.parts[e];i.render&&t.needs(e)&&(this.svg+=this.openGroup(this.idPrefix+"part-"+e,i.attributes),this.svg+=this.renderPart(i),this.svg+=this.closeGroup())}return this.svg+=this.closeGroup(),this.svg+=this.nl()+"</svg>",this.svg+=this.renderComments(this.footer),this.runHooks("postRender"),this.svg},Svg.prototype.renderSvgTag=function(t){var e="<svg";return this.indent(),e+=this.nl()+this.attributes.render(),this.outdent(),e+=this.nl()+">"+this.nl()},Svg.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},Svg.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},Svg.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},Svg.prototype.renderComments=function(t){return this.nl()+this.nl()+"\x3c!--"+this.nl()+t+this.nl()+"--\x3e"},Svg.prototype.renderPart=function(t){var e="";for(var i in t.paths){var r=t.paths[i];r.render&&(e+=this.renderPath(r))}for(var n in t.points)t.points[n].attributes.get("data-text")&&(e+=this.renderText(t.points[n])),t.points[n].attributes.get("data-circle")&&(e+=this.renderCircle(t.points[n]));for(var o in t.snippets){var s=t.snippets[o];e+=this.renderSnippet(s,t)}return e},Svg.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},Svg.prototype.renderPathText=function(t){var e=t.attributes.get("data-text");if(!e)return"";this.text=this.insertText(e);var i=t.attributes.renderIfPrefixIs("data-text-"),r="",n=t.attributes.get("data-text-class");n&&n.indexOf("center")>-1?r=' startOffset="50%" ':n&&n.indexOf("right")>-1&&(r=' startOffset="100%" ');var o=this.nl()+"<text>";return this.indent(),o+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+r+"><tspan "+i+">"+this.text+"</tspan></textPath>",this.outdent(),o+=this.nl()+"</text>"},Svg.prototype.renderText=function(t){var e=t.attributes.getAsArray("data-text");if(!1!==e){var i="",r=!0,n=!1,o=void 0;try{for(var s,a=e[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;this.text=this.insertText(h),i+=this.text+" "}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}this.text=this.insertText(i)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var p=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var y=this.text.split("\n");u+="<tspan>"+y.shift()+"</tspan>";var f=!0,l=!1,c=void 0;try{for(var v,d=y[Symbol.iterator]();!(f=(v=d.next()).done);f=!0){var x=v.value;u+='<tspan x="'+t.x+'" dy="'+p+'">'+x+"</tspan>"}}catch(t){l=!0,c=t}finally{try{!f&&d.return&&d.return()}finally{if(l)throw c}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},Svg.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},Svg.prototype.renderSnippet=function(t,e){var i=t.anchor.x,r=t.anchor.y,n=t.attributes.get("data-scale");n&&(t.attributes.add("transform","translate("+i+", "+r+")"),t.attributes.add("transform","scale("+n+")"),t.attributes.add("transform","translate("+-1*i+", "+-1*r+")"));var o=t.attributes.get("data-rotate");o&&t.attributes.add("transform","rotate("+o+", "+i+", "+r+")");var s=this.nl();return s+='<use x="'+i+'" y="'+r+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},Svg.prototype.openGroup=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.nl()+this.nl();return i+="\x3c!-- Start of group #"+t+" --\x3e",i+=this.nl(),i+='<g id="'+t+'"',e&&(i+=" "+e.render()),i+=">",this.indent(),this.openGroups.push(t),i},Svg.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},Svg.prototype.nl=function(){return"\n"+this.tab()},Svg.prototype.tab=function(){for(var t="",e=0;e<this.tabs;e++)t+="  ";return t},Svg.prototype.indent=function(){this.tabs+=1},Svg.prototype.outdent=function(){this.tabs-=1},Svg.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Store.prototype.set=function(t,e){this.data.set(t,e)},Store.prototype.setIfUnset=function(t,e){this.data.has(t)||this.data.set(t,e)},Store.prototype.get=function(t){return this.data.get(t)};var hooks={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function Pattern(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];for(var e in this.config=t||{},this.width=!1,this.height=!1,this.is="",this.store=new Store,this.parts={},this.hooks=hooks,this.Part=Part,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies),t.options){var i=t.options[e];if("object"===(void 0===i?"undefined":_typeof(i)))if(void 0!==i.pct)this.settings.options[e]=i.pct/100;else if(void 0!==i.mm)this.settings.options[e]=i.mm;else if(void 0!==i.deg)this.settings.options[e]=i.deg;else if(void 0!==i.count)this.settings.options[e]=i.count;else{if(void 0===i.dflt)throw"Unknown option type";this.settings.options[e]=i.dflt}else this.settings.options[e]=i}this.context={parts:this.parts,config:this.config,settings:this.settings,store:this.store}}Pattern.prototype.createPart=function(){var t=new Part;return t.context=this.context,t},Pattern.prototype.mergeSettings=function(t){var e=!0,i=!1,r=void 0;try{for(var n,o=Object.keys(t)[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;"object"===_typeof(t[s])?this.settings[s]=_extends({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}},Pattern.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var i=this.hooks[t];if(i.length>0){var r=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;h.method(e,h.data)}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}}},Pattern.prototype.draft=function(){this.is="draft",this.runHooks("preDraft");var t=!0,e=!1,i=void 0;try{for(var r,n=this.config.draftOrder[Symbol.iterator]();!(t=(r=n.next()).done);t=!0){var o=r.value,s=this.createPart();if("string"==typeof this.config.inject[o]&&s.inject(this.parts[this.config.inject[o]]),this.needs(o)){var a="draft"+capitalize(o);if("function"!=typeof this[a])throw new Error('Method "'+a+'" on pattern object is not callable');this.parts[o]=this[a](s),this.parts[o].render=this.wants(o)}}}catch(t){e=!0,i=t}finally{try{!t&&n.return&&n.return()}finally{if(e)throw i}}return this.runHooks("postDraft"),this},Pattern.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},Pattern.prototype.sampleParts=function(){var t={};for(var e in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[e]=this.createPart(),t[e].render=this.parts[e].render;return t},Pattern.prototype.sampleRun=function(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var o in this.draft(),this.parts){var s=0,a=0;for(var h in this.parts[o].points.anchor&&(void 0===e[o]?e[o]=this.parts[o].points.anchor:e[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(e[o]),a=this.parts[o].points.anchor.dy(e[o]))),this.parts[o].paths)t[o].paths[h+"_"+i]=this.parts[o].paths[h].clone().attr("style",sampleStyle(i,r)),this.parts[o].points.anchor&&(t[o].paths[h+"_"+i]=t[o].paths[h+"_"+i].translate(s,a)),!1!==n&&t[o].paths[h+"_"+i].attributes.add("class",n)}},Pattern.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var e,i=void 0,r=1,n={},o=this.sampleParts(),s=this.config.options[t];if("object"===_typeof(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(r=100),i=s.min/r,e=(s.max/r-i)/9;for(var a=1;a<11;a++)this.settings.options[t]=i,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+round(i)),this.sampleRun(o,n,a,10),i+=e;return this.parts=o,this.runHooks("postSample"),this},Pattern.prototype.sampleListOption=function(t){var e=this.sampleParts(),i=this.config.options[t],r={},n=1,o=i.list.length,s=!0,a=!1,h=void 0;try{for(var p,u=i.list[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var y=p.value;this.settings.options[t]=y,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+round(y)),this.sampleRun(e,r,n,o),n++}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return this.parts=e,this},Pattern.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var e={},i=this.sampleParts(),r=this.settings.measurements[t];if(void 0===r)throw"Cannot sample a measurement that is undefined";var n=r/50;r*=.9;for(var o=1;o<11;o++)this.settings.measurements[t]=r,this.debug("info","🏃🏿‍♀️ Sample run","Sampling measurement "+t+" with value "+round(r)),this.sampleRun(i,e,o,10),r+=n;return this.parts=i,this.runHooks("postSample"),this},Pattern.prototype.sampleModels=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var i={},r=this.sampleParts(),n=0,o=Object.keys(t).length;for(var s in t){n++,this.settings.measurements=t[s],this.debug("info","🏃🏿‍♀️ Sample run","Sampling model "+s);var a=s===e?"sample-focus":"";this.sampleRun(r,i,n,o,a)}return this.parts=r,this.runHooks("postSample"),this},Pattern.prototype.debug=function(){for(var t=arguments.length,e=Array(t),i=0;i<t;i++)e[i]=arguments[i];this.runHooks("debug",e)},Pattern.prototype.render=function(){return this.svg=new Svg(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},Pattern.prototype.on=function(t,e,i){this.hooks[t].push({method:e,data:i})},Pattern.prototype.with=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug("success","🔌 Plugin loaded",t.name+" v"+t.version),t.hooks&&this.loadPluginHooks(t,e),t.macros&&this.loadPluginMacros(t),this},Pattern.prototype.loadPluginHooks=function(t,e){var i=!0,r=!1,n=void 0;try{for(var o,s=Object.keys(this.hooks)[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value;if("function"==typeof t.hooks[a])this.on(a,t.hooks[a],e);else if("object"===_typeof(t.hooks[a])){var h=!0,p=!1,u=void 0;try{for(var y,f=t.hooks[a][Symbol.iterator]();!(h=(y=f.next()).done);h=!0){var l=y.value;this.on(a,l,e)}}catch(t){p=!0,u=t}finally{try{!h&&f.return&&f.return()}finally{if(p)throw u}}}}}catch(t){r=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(r)throw n}}},Pattern.prototype.loadPluginMacros=function(t){for(var e in t.macros)"function"==typeof t.macros[e]&&this.macro(e,t.macros[e])},Pattern.prototype.macro=function(t,e){this.Part.prototype[macroName(t)]=e},Pattern.prototype.pack=function(){var t=[];for(var e in this.parts){var i=this.parts[e];i.attributes.set("transform",""),i.render&&this.needs(e)&&(i.stack(),t.push({id:e,width:i.bottomRight.x-i.topLeft.x,height:i.bottomRight.y-i.topLeft.y}))}var r=pack(t,{inPlace:!0}),n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=this.parts[p.id];0===p.x&&0===p.y||u.attr("transform","translate ("+p.x+", "+p.y+")")}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return this.width=r.width,this.height=r.height,this},Pattern.prototype.draftOrder=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.resolveDependencies(),e=[],i={};return Object.keys(t).forEach(function r(n,o){Array.isArray(o)||(o=[]),o.push(n),i[n]=!0,void 0!==t[n]&&t[n].forEach(function(t){if(o.indexOf(t)>=0)throw new Error('Circular dependency "'+t+'" is required by "'+n+'": '+o.join(" -> "));i[t]||r(t,o.slice(0))}),e.indexOf(n)<0&&e.push(n)}),e},Pattern.prototype.resolveDependency=function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.config.dependencies,r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];return void 0===t[e]&&(t[e]=!0),"string"==typeof i[e]?(r.push(i[e]),this.resolveDependency(t,i[e],i,r)):r},Pattern.prototype.resolveDependencies=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.config.dependencies,e={},i={},r=!0,n=!1,o=void 0;try{for(var s,a=Object.keys(t)[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;e[h]=this.resolveDependency(i,h,t)}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}var p=!0,u=!1,y=void 0;try{for(var f,l=Object.keys(i)[Symbol.iterator]();!(p=(f=l.next()).done);p=!0){var c=f.value;void 0===e[c]&&(e[c]=[])}}catch(t){u=!0,y=t}finally{try{!p&&l.return&&l.return()}finally{if(u)throw y}}return e},Pattern.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only])){var e=!0,i=!1,r=void 0;try{for(var n,o=this.config.resolvedDependencies[this.settings.only][Symbol.iterator]();!(e=(n=o.next()).done);e=!0){if(n.value===t)return!0}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}}}else if(Array.isArray(this.settings.only)){var s=!0,a=!1,h=void 0;try{for(var p,u=this.settings.only[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var y=p.value;if(y===t)return!0;var f=!0,l=!1,c=void 0;try{for(var v,d=this.config.resolvedDependencies[y][Symbol.iterator]();!(f=(v=d.next()).done);f=!0){if(v.value===t)return!0}}catch(t){l=!0,c=t}finally{try{!f&&d.return&&d.return()}finally{if(l)throw c}}}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}}return!1},Pattern.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},Pattern.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){var e=!0,i=!1,r=void 0;try{for(var n,o=this.settings.only[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){if(n.value===t)return!0}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}return!1}}return!0};var index={version:version,Pattern:Pattern,Point:Point,Path:Path,Snippet:Snippet,utils:utils,patterns:{},plugins:{}};module.exports=index;
//# sourceMappingURL=index.js.map
