/**
 * freesewing | v0.22.1
 * A library for creating made-to-measure sewing patterns
 * (c) 2018 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
import"crypto";function Attributes(){this.list={}}function Point(t,e){this.x=round(t),this.y=round(e),this.attributes=new Attributes}function createCommonjsModule(t,e){return t(e={exports:{}},e.exports),e.exports}Attributes.prototype.add=function(t,e){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(e),this},Attributes.prototype.set=function(t,e){return this.list[t]=[e],this},Attributes.prototype.remove=function(t){return delete this.list[t],this},Attributes.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},Attributes.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},Attributes.prototype.render=function(){var t="";for(var e in this.list)t+=" "+e+'="'+this.list[e].join(" ")+'"';return t},Attributes.prototype.renderAsCss=function(){var t="";for(var e in this.list)t+=" "+e+":"+this.list[e].join(" ")+";";return t},Attributes.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",e="",i=t.length;for(var r in this.list)r.substr(0,i)===t&&(e+=" "+r.substr(i)+'="'+this.list[r].join(" ")+'"');return e},Attributes.prototype.clone=function(){var t=new Attributes;return t.list=JSON.parse(JSON.stringify(this.list)),t},Point.prototype.rad2deg=function(t){return 57.29577951308232*t},Point.prototype.deg2rad=function(t){return t/57.29577951308232},Point.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Point.prototype.dist=function(t){var e=this.x-t.x,i=this.y-t.y;return round(Math.sqrt(Math.pow(e,2)+Math.pow(i,2)))},Point.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},Point.prototype.dx=function(t){return t.x-this.x},Point.prototype.dy=function(t){return t.y-this.y},Point.prototype.angle=function(t){for(var e=Math.atan2(-1*this.dy(t),this.dx(t));e<0;)e+=2*Math.PI;return this.rad2deg(e)},Point.prototype.rotate=function(t,e){var i=this.dist(e),r=this.angle(e);return new Point(e.x+i*Math.cos(this.deg2rad(r+t))*-1,e.y+i*Math.sin(this.deg2rad(r+t)))},Point.prototype.copy=function(){return new Point(this.x,this.y)},Point.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(!1===t?-1*this.x:t.x+this.dx(t),this.y)},Point.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(this.x,!1===t?-1*this.y:t.y+this.dy(t))},Point.prototype.shift=function(t,e){var i=this.copy();return i.x+=e,i.rotate(t,this)},Point.prototype.shiftTowards=function(t,e){return this.shift(this.angle(t),e)},Point.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},Point.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},Point.prototype.shiftFractionTowards=function(t,e){return this.shiftTowards(t,this.dist(t)*e)},Point.prototype.shiftOutwards=function(t,e){return this.shiftTowards(t,this.dist(t)+e)},Point.prototype.clone=function(){var t=new Point(this.x,this.y);return t.attributes=this.attributes.clone(),t},Point.prototype.translate=function(t,e){var i=this.copy();return i.x+=t,i.y+=e,i};var utils=createCommonjsModule(function(t){var e,i,r,n,o,s,a,h,p,u,f,c,y,l;e=Math.abs,i=Math.cos,r=Math.sin,n=Math.acos,o=Math.atan2,s=Math.sqrt,a=Math.pow,h=function(t){return t<0?-a(-t,1/3):a(t,1/3)},p=Math.PI,u=2*p,f=p/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,y=Number.MIN_SAFE_INTEGER||-9007199254740991,l={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,e){var i=e(t),r=i.x*i.x+i.y*i.y;return void 0!==i.z&&(r+=i.z*i.z),s(r)},between:function(t,e,i){return e<=t&&t<=i||l.approximately(t,e)||l.approximately(t,i)},approximately:function(t,i,r){return e(t-i)<=(r||1e-6)},length:function(t){var e,i,r=0,n=l.Tvalues.length;for(e=0;e<n;e++)i=.5*l.Tvalues[e]+.5,r+=l.Cvalues[e]*l.arcfn(i,t);return.5*r},map:function(t,e,i,r,n){return r+(n-r)*((t-e)/(i-e))},lerp:function(t,e,i){var r={x:e.x+t*(i.x-e.x),y:e.y+t*(i.y-e.y)};return e.z&&i.z&&(r.z=e.z+t*(i.z-e.z)),r},pointToString:function(t){var e=t.x+"/"+t.y;return void 0!==t.z&&(e+="/"+t.z),e},pointsToString:function(t){return"["+t.map(l.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,e,i){var r=e.x-t.x,n=e.y-t.y,s=i.x-t.x,a=i.y-t.y;return o(r*a-n*s,r*s+n*a)},round:function(t,e){var i=""+t,r=i.indexOf(".");return parseFloat(i.substring(0,r+1+e))},dist:function(t,e){var i=t.x-e.x,r=t.y-e.y;return s(i*i+r*r)},closest:function(t,e){var i,r,n=a(2,63);return t.forEach(function(t,o){(r=l.dist(e,t))<n&&(n=r,i=o)}),{mdist:n,mpos:i}},abcratio:function(t,i){if(2!==i&&3!==i)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var r=a(t,i)+a(1-t,i);return e((r-1)/r)},projectionratio:function(t,e){if(2!==e&&3!==e)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var i=a(1-t,e);return i/(a(t,e)+i)},lli8:function(t,e,i,r,n,o,s,a){var h=(t-i)*(o-a)-(e-r)*(n-s);return 0!=h&&{x:((t*r-e*i)*(n-s)-(t-i)*(n*a-o*s))/h,y:((t*r-e*i)*(o-a)-(e-r)*(n*a-o*s))/h}},lli4:function(t,e,i,r){var n=t.x,o=t.y,s=e.x,a=e.y,h=i.x,p=i.y,u=r.x,f=r.y;return l.lli8(n,o,s,a,h,p,u,f)},lli:function(t,e){return l.lli4(t,t.c,e,e.c)},makeline:function(t,e){var i=bezier,r=t.x,n=t.y,o=e.x,s=e.y,a=(o-r)/3,h=(s-n)/3;return new i(r,n,r+a,n+h,r+2*a,n+2*h,o,s)},findbbox:function(t){var e=c,i=c,r=y,n=y;return t.forEach(function(t){var o=t.bbox();e>o.x.min&&(e=o.x.min),i>o.y.min&&(i=o.y.min),r<o.x.max&&(r=o.x.max),n<o.y.max&&(n=o.y.max)}),{x:{min:e,mid:(e+r)/2,max:r,size:r-e},y:{min:i,mid:(i+n)/2,max:n,size:n-i}}},shapeintersections:function(t,e,i,r,n){if(!l.bboxoverlap(e,r))return[];var o=[],s=[t.startcap,t.forward,t.back,t.endcap],a=[i.startcap,i.forward,i.back,i.endcap];return s.forEach(function(e){e.virtual||a.forEach(function(r){if(!r.virtual){var s=e.intersects(r,n);s.length>0&&(s.c1=e,s.c2=r,s.s1=t,s.s2=i,o.push(s))}})}),o},makeshape:function(t,e,i){var r=e.points.length,n=t.points.length,o=l.makeline(e.points[r-1],t.points[0]),s=l.makeline(t.points[n-1],e.points[0]),a={startcap:o,forward:t,back:e,endcap:s,bbox:l.findbbox([o,t,e,s])},h=l;return a.intersections=function(t){return h.shapeintersections(a,a.bbox,t,t.bbox,i)},a},getminmax:function(t,e,i){if(!i)return{min:0,max:0};var r,n,o=c,s=y;-1===i.indexOf(0)&&(i=[0].concat(i)),-1===i.indexOf(1)&&i.push(1);for(var a=0,h=i.length;a<h;a++)r=i[a],(n=t.get(r))[e]<o&&(o=n[e]),n[e]>s&&(s=n[e]);return{min:o,mid:(o+s)/2,max:s,size:s-o}},align:function(t,e){var n=e.p1.x,s=e.p1.y,a=-o(e.p2.y-s,e.p2.x-n);return t.map(function(t){return{x:(t.x-n)*i(a)-(t.y-s)*r(a),y:(t.x-n)*r(a)+(t.y-s)*i(a)}})},roots:function(t,e){e=e||{p1:{x:0,y:0},p2:{x:1,y:0}};var r=t.length-1,o=l.align(t,e),a=function(t){return 0<=t&&t<=1};if(2===r){if(0!==(d=(x=o[0].y)-2*(g=o[1].y)+(m=o[2].y))){var p=-s(g*g-x*m),f=-x+g;return[-(p+f)/d,-(-p+f)/d].filter(a)}return g!==m&&0===d?[(2*g-m)/2*(g-m)].filter(a):[]}var c=o[0].y,y=o[1].y,v=o[2].y,d=3*y-c-3*v+o[3].y,x=3*c-6*y+3*v,g=-3*c+3*y,m=c;if(l.approximately(d,0)){if(l.approximately(x,0))return l.approximately(g,0)?[]:[-m/g].filter(a);var b=2*x;return[((w=s(g*g-4*x*m))-g)/b,(-g-w)/b].filter(a)}var w,P,z=(o=(3*(g/=d)-(x/=d)*x)/3)/3,S=(w=(2*x*x*x-9*x*g+27*(m/=d))/27)/2,O=S*S+z*z*z;if(O<0){var _=-o/3,M=s(_*_*_),k=-w/(2*M),I=n(k<-1?-1:k>1?1:k),L=2*h(M);return[L*i(I/3)-x/3,L*i((I+u)/3)-x/3,L*i((I+2*u)/3)-x/3].filter(a)}if(0===O)return[2*(P=S<0?h(-S):-h(S))-x/3,-P-x/3].filter(a);var A=s(O);return[(P=h(-S+A))-h(S+A)-x/3].filter(a)},droots:function(t){if(3===t.length){var e=t[0],i=t[1],r=t[2],n=e-2*i+r;if(0!==n){var o=-s(i*i-e*r),a=-e+i;return[-(o+a)/n,-(-o+a)/n]}return i!==r&&0===n?[(2*i-r)/(2*(i-r))]:[]}if(2===t.length)return(e=t[0])!==(i=t[1])?[e/(e-i)]:[]},inflections:function(t){if(t.length<4)return[];var e=l.align(t,{p1:t[0],p2:t.slice(-1)[0]}),i=e[2].x*e[1].y,r=e[3].x*e[1].y,n=e[1].x*e[2].y,o=18*(-3*i+2*r+3*n-(f=e[3].x*e[2].y)),s=18*(3*i-r-3*n),a=18*(n-i);if(l.approximately(o,0)){if(!l.approximately(s,0)){var h=-a/s;if(0<=h&&h<=1)return[h]}return[]}var p=s*s-4*o*a,u=Math.sqrt(p),f=2*o;return l.approximately(f,0)?[]:[(u-s)/f,-(s+u)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,i){var r,n,o,s,a,h=["x","y"],p=h.length;for(r=0;r<p;r++)if(o=t[n=h[r]].mid,s=i[n].mid,a=(t[n].size+i[n].size)/2,e(o-s)>=a)return!1;return!0},expandbox:function(t,e){e.x.min<t.x.min&&(t.x.min=e.x.min),e.y.min<t.y.min&&(t.y.min=e.y.min),e.z&&e.z.min<t.z.min&&(t.z.min=e.z.min),e.x.max>t.x.max&&(t.x.max=e.x.max),e.y.max>t.y.max&&(t.y.max=e.y.max),e.z&&e.z.max>t.z.max&&(t.z.max=e.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,e,i){var r=t.bbox(),n=e.bbox(),o=1e5,s=i||.5;if(r.x.size+r.y.size<s&&n.x.size+n.y.size<s)return[(o*(t._t1+t._t2)/2|0)/o+"/"+(o*(e._t1+e._t2)/2|0)/o];var a=t.split(.5),h=e.split(.5),p=[{left:a.left,right:h.left},{left:a.left,right:h.right},{left:a.right,right:h.right},{left:a.right,right:h.left}];p=p.filter(function(t){return l.bboxoverlap(t.left.bbox(),t.right.bbox())});var u=[];return 0===p.length?u:(p.forEach(function(t){u=u.concat(l.pairiteration(t.left,t.right,s))}),u=u.filter(function(t,e){return u.indexOf(t)===e}))},getccenter:function(t,e,n){var s,a=e.x-t.x,h=e.y-t.y,p=n.x-e.x,c=n.y-e.y,y=a*i(f)-h*r(f),v=a*r(f)+h*i(f),d=p*i(f)-c*r(f),x=p*r(f)+c*i(f),g=(t.x+e.x)/2,m=(t.y+e.y)/2,b=(e.x+n.x)/2,w=(e.y+n.y)/2,P=g+y,z=m+v,S=b+d,O=w+x,_=l.lli8(g,m,P,z,b,w,S,O),M=l.dist(_,t),k=o(t.y-_.y,t.x-_.x),I=o(e.y-_.y,e.x-_.x),L=o(n.y-_.y,n.x-_.x);return k<L?((k>I||I>L)&&(k+=u),k>L&&(s=L,L=k,k=s)):L<I&&I<k?(s=L,L=k,k=s):L+=u,_.s=k,_.e=L,_.r=M,_},numberSort:function(t,e){return t-e}},t.exports=l}),polyBezier=createCommonjsModule(function(t){var e,i;e=utils,(i=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return e.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,e){return t+e})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,i=t[0].bbox(),r=1;r<t.length;r++)e.expandbox(i,t[r].bbox());return i},offset:function(t){var e=[];return this.curves.forEach(function(i){e=e.concat(i.offset(t))}),new i(e)}},t.exports=i});function normalizePath(t){var e,i,r,n,o,s,a=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),h=a.length,p=[],u=0,f=0,c=0,y=0,l=0,v=0,d=0,x=0,g="";for(e=1;e<h;e++)if(n=(r=(i=a[e]).substring(0,1)).toLowerCase(),o=(p=(p=i.replace(r,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===n){if(g+="M ","m"===r?(c+=p[0],y+=p[1]):(c=p[0],y=p[1]),u=c,f=y,g+=c+" "+y+" ",o>2)for(s=0;s<o;s+=2)"m"===r?(c+=p[s],y+=p[s+1]):(c=p[s],y=p[s+1]),g+=["L",c,y,""].join(" ")}else if("l"===n)for(s=0;s<o;s+=2)"l"===r?(c+=p[s],y+=p[s+1]):(c=p[s],y=p[s+1]),g+=["L",c,y,""].join(" ");else if("h"===n)for(s=0;s<o;s++)"h"===r?c+=p[s]:c=p[s],g+=["L",c,y,""].join(" ");else if("v"===n)for(s=0;s<o;s++)"v"===r?y+=p[s]:y=p[s],g+=["L",c,y,""].join(" ");else if("q"===n)for(s=0;s<o;s+=4)"q"===r?(l=c+p[s],v=y+p[s+1],c+=p[s+2],y+=p[s+3]):(l=p[s],v=p[s+1],c=p[s+2],y=p[s+3]),g+=["Q",l,v,c,y,""].join(" ");else if("t"===n)for(s=0;s<o;s+=2)l=c+(c-l),v=y+(y-v),"t"===r?(c+=p[s],y+=p[s+1]):(c=p[s],y=p[s+1]),g+=["Q",l,v,c,y,""].join(" ");else if("c"===n)for(s=0;s<o;s+=6)"c"===r?(l=c+p[s],v=y+p[s+1],d=c+p[s+2],x=y+p[s+3],c+=p[s+4],y+=p[s+5]):(l=p[s],v=p[s+1],d=p[s+2],x=p[s+3],c=p[s+4],y=p[s+5]),g+=["C",l,v,d,x,c,y,""].join(" ");else if("s"===n)for(s=0;s<o;s+=4)l=c+(c-d),v=y+(y-x),"s"===r?(d=c+p[s],x=y+p[s+1],c+=p[s+2],y+=p[s+3]):(d=p[s],x=p[s+1],c=p[s+2],y=p[s+3]),g+=["C",l,v,d,x,c,y,""].join(" ");else"z"===n&&(g+="Z ",c=u,y=f);return g.trim()}var normaliseSvg=normalizePath,M={x:!1,y:!1};function makeBezier(t,e,i){if("Z"!==e){if("M"!==e){var r=[!1,M.x,M.y].concat(i),n=new(t.bind.apply(t,r)),o=i.slice(-2);return M={x:o[0],y:o[1]},n}M={x:i[0],y:i[1]}}}function convertPath(t,e){for(var i,r,n=normaliseSvg(e).split(" "),o=new RegExp("[MLCQZ]",""),s=[],a={C:6,Q:4,L:2,M:2};n.length;)i=n.splice(0,1)[0],o.test(i)&&(r=makeBezier(t,i,n.splice(0,a[i]).map(parseFloat)))&&s.push(r);return new t.PolyBezier(s)}var svgToBeziers=convertPath,bezier=createCommonjsModule(function(t){!function(){var e=Math.abs,i=Math.min,r=Math.max,n=Math.cos,o=Math.sin,s=Math.acos,a=Math.sqrt,h=Math.PI,p={x:0,y:0,z:0},u=utils,f=polyBezier,c=function(t){var i=t&&t.forEach?t:[].slice.call(arguments),r=!1;if("object"==typeof i[0]){r=i.length;var n=[];i.forEach(function(t){["x","y","z"].forEach(function(e){void 0!==t[e]&&n.push(t[e])})}),i=n}var o=!1,s=i.length;if(r){if(r>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");o=!0}}else if(6!==s&&8!==s&&9!==s&&12!==s&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var a=!o&&(9===s||12===s)||t&&t[0]&&void 0!==t[0].z;this._3d=a;for(var h=[],p=0,f=a?3:2;p<s;p+=f){var c={x:i[p],y:i[p+1]};a&&(c.z=i[p+2]),h.push(c)}this.order=h.length-1,this.points=h;var y=["x","y"];a&&y.push("z"),this.dims=y,this.dimlen=y.length,function(t){for(var i=t.order,r=t.points,n=u.align(r,{p1:r[0],p2:r[i]}),o=0;o<n.length;o++)if(e(n[o].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},y=svgToBeziers;function l(t,e,i,r,n){void 0===n&&(n=.5);var o=u.projectionratio(n,t),s=1-o,a={x:o*e.x+s*r.x,y:o*e.y+s*r.y},h=u.abcratio(n,t);return{A:{x:i.x+(i.x-a.x)/h,y:i.y+(i.y-a.y)/h},B:i,C:a}}c.SVGtoBeziers=function(t){return y(c,t)},c.quadraticFromPoints=function(t,e,i,r){if(void 0===r&&(r=.5),0===r)return new c(e,e,i);if(1===r)return new c(t,e,e);var n=l(2,t,e,i,r);return new c(t,n.A,i)},c.cubicFromPoints=function(t,e,i,r,n){void 0===r&&(r=.5);var o=l(3,t,e,i,r);void 0===n&&(n=u.dist(e,o.C));var s=n*(1-r)/r,a=u.dist(t,i),h=(i.x-t.x)/a,p=(i.y-t.y)/a,f=n*h,y=n*p,v=s*h,d=s*p,x=e.x-f,g=e.y-y,m=e.x+v,b=e.y+d,w=o.A,P=w.x+(x-w.x)/(1-r),z=w.y+(g-w.y)/(1-r),S=w.x+(m-w.x)/r,O=w.y+(b-w.y)/r,_={x:t.x+(P-t.x)/r,y:t.y+(z-t.y)/r},M={x:i.x+(S-i.x)/(1-r),y:i.y+(O-i.y)/(1-r)};return new c(t,_,M,i)};var v=function(){return u};c.getUtils=v,c.PolyBezier=f,c.prototype={getUtils:v,valueOf:function(){return this.toString()},toString:function(){return u.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var e=this.points,i=["M",e[0].x,e[0].y,2===this.order?"Q":"C"],r=1,n=e.length;r<n;r++)i.push(e[r].x),i.push(e[r].y);return i.join(" ")},update:function(){this.dpoints=[];for(var t=this.points,e=t.length,i=e-1;e>1;e--,i--){for(var r,n=[],o=0;o<i;o++)r={x:i*(t[o+1].x-t[o].x),y:i*(t[o+1].y-t[o].y)},this._3d&&(r.z=i*(t[o+1].z-t[o].z)),n.push(r);this.dpoints.push(n),t=n}this.computedirection()},computedirection:function(){var t=this.points,e=u.angle(t[0],t[this.order],t[1]);this.clockwise=e>0},length:function(){return u.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var e=0;e<=t;e++)this._lut.push(this.compute(e/t));return this._lut},on:function(t,e){e=e||5;for(var i,r=this.getLUT(),n=[],o=0,s=0;s<r.length;s++)i=r[s],u.dist(i,t)<e&&(n.push(i),o+=s/r.length);return!!n.length&&o/n.length},project:function(t){var e=this.getLUT(),i=e.length-1,r=u.closest(e,t),n=r.mdist,o=r.mpos;if(0===o||o===i){var s=o/i,a=this.compute(s);return a.t=s,a.d=n,a}var h,p,f,c=(o+1)/i,y=.1/i;for(n+=1,h=s=(o-1)/i;s<c+y;s+=y)p=this.compute(s),(f=u.dist(t,p))<n&&(n=f,h=s);return(p=this.compute(h)).t=h,p.d=n,p},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){if(0===t)return this.points[0];if(1===t)return this.points[this.order];var e=this.points,i=1-t;if(1===this.order)return u={x:i*e[0].x+t*e[1].x,y:i*e[0].y+t*e[1].y},this._3d&&(u.z=i*e[0].z+t*e[1].z),u;if(this.order<4){var r,n,o,s=i*i,a=t*t,h=0;2===this.order?(e=[e[0],e[1],e[2],p],r=s,n=i*t*2,o=a):3===this.order&&(r=s*i,n=s*t*3,o=i*a*3,h=t*a);var u={x:r*e[0].x+n*e[1].x+o*e[2].x+h*e[3].x,y:r*e[0].y+n*e[1].y+o*e[2].y+h*e[3].y};return this._3d&&(u.z=r*e[0].z+n*e[1].z+o*e[2].z+h*e[3].z),u}for(var f=JSON.parse(JSON.stringify(this.points));f.length>1;){for(var c=0;c<f.length-1;c++)f[c]={x:f[c].x+(f[c+1].x-f[c].x)*t,y:f[c].y+(f[c+1].y-f[c].y)*t},void 0!==f[c].z&&(f[c]=f[c].z+(f[c+1].z-f[c].z)*t);f.splice(f.length-1,1)}return f[0]},raise:function(){for(var t,e,i=this.points,r=[i[0]],n=i.length,o=1;o<n;o++)t=i[o],e=i[o-1],r[o]={x:(n-o)/n*t.x+o/n*e.x,y:(n-o)/n*t.y+o/n*e.y};return r[n]=i[n-1],new c(r)},derivative:function(t){var e,i,r=1-t,n=0,o=this.dpoints[0];2===this.order&&(o=[o[0],o[1],p],e=r,i=t),3===this.order&&(e=r*r,i=r*t*2,n=t*t);var s={x:e*o[0].x+i*o[1].x+n*o[2].x,y:e*o[0].y+i*o[1].y+n*o[2].y};return this._3d&&(s.z=e*o[0].z+i*o[1].z+n*o[2].z),s},inflections:function(){return u.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var e=this.derivative(t),i=a(e.x*e.x+e.y*e.y);return{x:-e.y/i,y:e.x/i}},__normal3:function(t){var e=this.derivative(t),i=this.derivative(t+.01),r=a(e.x*e.x+e.y*e.y+e.z*e.z),n=a(i.x*i.x+i.y*i.y+i.z*i.z);e.x/=r,e.y/=r,e.z/=r,i.x/=n,i.y/=n,i.z/=n;var o={x:i.y*e.z-i.z*e.y,y:i.z*e.x-i.x*e.z,z:i.x*e.y-i.y*e.x},s=a(o.x*o.x+o.y*o.y+o.z*o.z);o.x/=s,o.y/=s,o.z/=s;var h=[o.x*o.x,o.x*o.y-o.z,o.x*o.z+o.y,o.x*o.y+o.z,o.y*o.y,o.y*o.z-o.x,o.x*o.z-o.y,o.y*o.z+o.x,o.z*o.z];return{x:h[0]*e.x+h[1]*e.y+h[2]*e.z,y:h[3]*e.x+h[4]*e.y+h[5]*e.z,z:h[6]*e.x+h[7]*e.y+h[8]*e.z}},hull:function(t){var e,i=this.points,r=[],n=[],o=0,s=0,a=0;for(n[o++]=i[0],n[o++]=i[1],n[o++]=i[2],3===this.order&&(n[o++]=i[3]);i.length>1;){for(r=[],s=0,a=i.length-1;s<a;s++)e=u.lerp(t,i[s],i[s+1]),n[o++]=e,r.push(e);i=r}return n},split:function(t,e){if(0===t&&e)return this.split(e).left;if(1===e)return this.split(t).right;var i=this.hull(t),r={left:2===this.order?new c([i[0],i[3],i[5]]):new c([i[0],i[4],i[7],i[9]]),right:2===this.order?new c([i[5],i[4],i[2]]):new c([i[9],i[8],i[6],i[3]]),span:i};return r.left._t1=u.map(0,0,1,this._t1,this._t2),r.left._t2=u.map(t,0,1,this._t1,this._t2),r.right._t1=u.map(t,0,1,this._t1,this._t2),r.right._t2=u.map(1,0,1,this._t1,this._t2),e?(e=u.map(e,t,1,0,1),r.right.split(e).left):r},extrema:function(){var t,e,i=this.dims,r={},n=[];return i.forEach(function(i){e=function(t){return t[i]},t=this.dpoints[0].map(e),r[i]=u.droots(t),3===this.order&&(t=this.dpoints[1].map(e),r[i]=r[i].concat(u.droots(t))),r[i]=r[i].filter(function(t){return t>=0&&t<=1}),n=n.concat(r[i].sort(u.numberSort))}.bind(this)),n=n.sort(u.numberSort).filter(function(t,e){return n.indexOf(t)===e}),r.values=n,r},bbox:function(){var t=this.extrema(),e={};return this.dims.forEach(function(i){e[i]=u.getminmax(this,i,t[i])}.bind(this)),e},overlaps:function(t){var e=this.bbox(),i=t.bbox();return u.bboxoverlap(e,i)},offset:function(t,e){if(void 0!==e){var i=this.get(t),r=this.normal(t),n={c:i,n:r,x:i.x+r.x*e,y:i.y+r.y*e};return this._3d&&(n.z=i.z+r.z*e),n}if(this._linear){var o=this.normal(0),s=this.points.map(function(e){var i={x:e.x+t*o.x,y:e.y+t*o.y};return e.z&&r.z&&(i.z=e.z+t*o.z),i});return[new c(s)]}return this.reduce().map(function(e){return e.scale(t)})},simple:function(){if(3===this.order){var t=u.angle(this.points[0],this.points[3],this.points[1]),i=u.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&i<0||t<0&&i>0)return!1}var r=this.normal(0),n=this.normal(1),o=r.x*n.x+r.y*n.y;return this._3d&&(o+=r.z*n.z),e(s(o))<h/3},reduce:function(){var t,i,r=0,n=0,o=[],s=[],a=this.extrema().values;for(-1===a.indexOf(0)&&(a=[0].concat(a)),-1===a.indexOf(1)&&a.push(1),r=a[0],t=1;t<a.length;t++)n=a[t],(i=this.split(r,n))._t1=r,i._t2=n,o.push(i),r=n;return o.forEach(function(t){for(r=0,n=0;n<=1;)for(n=r+.01;n<=1.01;n+=.01)if(!(i=t.split(r,n)).simple()){if(e(r-(n-=.01))<.01)return[];(i=t.split(r,n))._t1=u.map(r,0,1,t._t1,t._t2),i._t2=u.map(n,0,1,t._t1,t._t2),s.push(i),r=n;break}r<1&&((i=t.split(r,1))._t1=u.map(r,0,1,t._t1,t._t2),i._t2=t._t2,s.push(i))}),s},scale:function(t){var e=this.order,i=!1;if("function"==typeof t&&(i=t),i&&2===e)return this.raise().scale(i);var r=this.clockwise,n=i?i(0):t,o=i?i(1):t,s=[this.offset(0,10),this.offset(1,10)],h=u.lli4(s[0],s[0].c,s[1],s[1].c);if(!h)throw new Error("cannot scale this curve. Try reducing it first.");var p=this.points,f=[];return[0,1].forEach(function(t){var i=f[t*e]=u.copy(p[t*e]);i.x+=(t?o:n)*s[t].n.x,i.y+=(t?o:n)*s[t].n.y}.bind(this)),i?([0,1].forEach(function(n){if(2!==this.order||!n){var o=p[n+1],s={x:o.x-h.x,y:o.y-h.y},u=i?i((n+1)/e):t;i&&!r&&(u=-u);var c=a(s.x*s.x+s.y*s.y);s.x/=c,s.y/=c,f[n+1]={x:o.x+u*s.x,y:o.y+u*s.y}}}.bind(this)),new c(f)):([0,1].forEach(function(t){if(2!==this.order||!t){var i=f[t*e],r=this.derivative(t),n={x:i.x+r.x,y:i.y+r.y};f[t+1]=u.lli4(i,n,h,p[t+1])}}.bind(this)),new c(f))},outline:function(t,e,i,r){e=void 0===e?t:e;var n,o=this.reduce(),s=o.length,a=[],h=[],p=0,c=this.length(),y=void 0!==i&&void 0!==r;function l(t,e,i,r,n){return function(o){var s=r/i,a=(r+n)/i,h=e-t;return u.map(o,0,1,t+s*h,t+a*h)}}o.forEach(function(n){P=n.length(),y?(a.push(n.scale(l(t,i,c,p,P))),h.push(n.scale(l(-e,-r,c,p,P)))):(a.push(n.scale(t)),h.push(n.scale(-e))),p+=P}),h=h.map(function(t){return(n=t.points)[3]?t.points=[n[3],n[2],n[1],n[0]]:t.points=[n[2],n[1],n[0]],t}).reverse();var v=a[0].points[0],d=a[s-1].points[a[s-1].points.length-1],x=h[s-1].points[h[s-1].points.length-1],g=h[0].points[0],m=u.makeline(x,v),b=u.makeline(d,g),w=[m].concat(a).concat([b]).concat(h),P=w.length;return new f(w)},outlineshapes:function(t,e,i){e=e||t;for(var r=this.outline(t,e).curves,n=[],o=1,s=r.length;o<s/2;o++){var a=u.makeshape(r[o],r[s-o],i);a.startcap.virtual=o>1,a.endcap.virtual=o<s/2-1,n.push(a)}return n},intersects:function(t,e){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof c&&(t=t.reduce()),this.curveintersects(this.reduce(),t,e)):this.selfintersects(e)},lineIntersects:function(t){var e=i(t.p1.x,t.p2.x),n=i(t.p1.y,t.p2.y),o=r(t.p1.x,t.p2.x),s=r(t.p1.y,t.p2.y),a=this;return u.roots(this.points,t).filter(function(t){var i=a.get(t);return u.between(i.x,e,o)&&u.between(i.y,n,s)})},selfintersects:function(t){var e,i,r,n,o=this.reduce(),s=o.length-2,a=[];for(e=0;e<s;e++)r=o.slice(e,e+1),n=o.slice(e+2),i=this.curveintersects(r,n,t),a=a.concat(i);return a},curveintersects:function(t,e,i){var r=[];t.forEach(function(t){e.forEach(function(e){t.overlaps(e)&&r.push({left:t,right:e})})});var n=[];return r.forEach(function(t){var e=u.pairiteration(t.left,t.right,i);e.length>0&&(n=n.concat(e))}),n},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,i,r,n){var o=(n-r)/4,s=this.get(r+o),a=this.get(n-o),h=u.dist(t,i),p=u.dist(t,s),f=u.dist(t,a);return e(p-h)+e(f-h)},_iterate:function(t,e){var i,r=0,s=1;do{i=0,s=1;var a,h,p,f,c,y=this.get(r),l=!1,v=!1,d=s,x=1;do{if(v=l,f=p,d=(r+s)/2,a=this.get(d),h=this.get(s),(p=u.getccenter(y,a,h)).interval={start:r,end:s},l=this._error(p,y,r,s)<=t,(c=v&&!l)||(x=s),l){if(s>=1){if(p.interval.end=x=1,f=p,s>1){var g={x:p.x+p.r*n(p.e),y:p.y+p.r*o(p.e)};p.e+=u.angle({x:p.x,y:p.y},g,this.get(1))}break}s+=(s-r)/2}else s=d}while(!c&&i++<100);if(i>=100)break;f=f||p,e.push(f),r=x}while(s<1);return e}},t.exports=c}()}),bezierJs=bezier;function capitalize(t){return t.charAt(0).toUpperCase()+t.slice(1)}function macroName(t){return"_macro_"+t}function beamsIntersect(t,e,i,r){var n=t.slope(e),o=i.slope(r);if(n===o)return!1;if(t.x===e.x)return new Point(t.x,o*t.x+(i.y-o*i.x));if(i.x===r.x)return new Point(i.x,n*i.x+(t.y-n*t.x));t.x>e.x&&(t=e.copy()),i.x>r.x&&(i=r.copy());var s=t.y-n*t.x,a=(i.y-o*i.x-s)/(n-o);return new Point(a,n*a+s)}function linesIntersect(t,e,i,r){var n=beamsIntersect(t,e,i,r);if(!n)return!1;var o=t.dist(e),s=i.dist(r),a=t.dist(n)+n.dist(e),h=i.dist(n)+n.dist(r);return Math.round(o)==Math.round(a)&&Math.round(s)==Math.round(h)&&n}function pointOnBeam(t,e,i){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(i))return!0;if(e.sitsOn(i))return!0;var n=i.dx(t)*e.dy(t)-i.dy(t)*e.dx(t);return 0===Math.abs(Math.round(n*r)/r)}function pointOnLine(t,e,i){if(!pointOnBeam(t,e,i,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var r=t.dist(e),n=t.dist(i)+i.dist(e);return Math.round(r)==Math.round(n)}function pointOnCurve(t,e,i,r,n){if(t.sitsOn(n))return!0;if(r.sitsOn(n))return!0;var o=new bezierJs({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:r.x,y:r.y}).intersects({p1:{x:n.x-1,y:n.y},p2:{x:n.x+1,y:n.y}});return o.length>0&&o.shift()}function beamIntersectsX(t,e,i){return t.x!==e.x&&beamsIntersect(t,e,new Point(i,-10),new Point(i,10))}function beamIntersectsY(t,e,i){return t.y!==e.y&&beamsIntersect(t,e,new Point(-10,i),new Point(10,i))}function units(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?round(t/25.4)+'"':round(t/10)+"cm"}function lineIntersectsCurve(t,e,i,r,n,o){var s=[],a=new bezierJs({x:i.x,y:i.y},{x:r.x,y:r.y},{x:n.x,y:n.y},{x:o.x,y:o.y}),h={p1:{x:t.x,y:t.y},p2:{x:e.x,y:e.y}},p=!0,u=!1,f=void 0;try{for(var c,y=a.intersects(h)[Symbol.iterator]();!(p=(c=y.next()).done);p=!0){var l=c.value,v=a.get(l);s.push(new Point(v.x,v.y))}}catch(t){u=!0,f=t}finally{try{!p&&y.return&&y.return()}finally{if(u)throw f}}return 0!==s.length&&(1===s.length?s[0]:s)}function curvesIntersect(t,e,i,r,n,o,s,a){var h=[],p=new bezierJs({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:r.x,y:r.y}),u=new bezierJs({x:n.x,y:n.y},{x:o.x,y:o.y},{x:s.x,y:s.y},{x:a.x,y:a.y}),f=!0,c=!1,y=void 0;try{for(var l,v=p.intersects(u,.005)[Symbol.iterator]();!(f=(l=v.next()).done);f=!0){var d=l.value,x=p.get(d.substr(0,d.indexOf("/")));h.push(new Point(x.x,x.y))}}catch(t){c=!0,y=t}finally{try{!f&&v.return&&v.return()}finally{if(c)throw y}}if(0===h.length)return!1;if(1===h.length)return h.shift();var g=[],m=!0,b=!1,w=void 0;try{for(var P,z=h[Symbol.iterator]();!(m=(P=z.next()).done);m=!0){var S=P.value,O=!1,_=!0,M=!1,k=void 0;try{for(var I,L=g[Symbol.iterator]();!(_=(I=L.next()).done);_=!0){var A=I.value;S.sitsRoughlyOn(A)&&(O=!0)}}catch(t){M=!0,k=t}finally{try{!_&&L.return&&L.return()}finally{if(M)throw k}}O||g.push(S)}}catch(t){b=!0,w=t}finally{try{!m&&z.return&&z.return()}finally{if(b)throw w}}return g}function circlesIntersect(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=t.dx(i),s=t.dy(i),a=t.dist(i);if(a>parseFloat(e)+parseFloat(r))return!1;if(a<parseFloat(r)-parseFloat(e))return!1;if(0===a&&e===r)return!1;var h=(Math.pow(e,2)-Math.pow(r,2)+Math.pow(a,2))/(2*a),p=Math.sqrt(Math.pow(e,2)-Math.pow(h,2)),u=t.x+h*o/a,f=t.y+h*s/a,c=new Point(u+p*s/a,f-p*o/a),y=new Point(u-p*s/a,f+p*o/a);return"x"===n&&c.x<=y.x||"y"===n&&c.y<=y.y?[c,y]:[y,c]}function beamIntersectsCircle(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=r.x-i.x,s=r.y-i.y,a=Math.pow(o,2)+Math.pow(s,2),h=2*(o*(i.x-t.x)+s*(i.y-t.y)),p=Math.pow(i.x-t.x,2)+Math.pow(i.y-t.y,2)-Math.pow(e,2),u=Math.pow(h,2)-4*a*p;if(a<=1e-7||u<0)return!1;if(0===u){var f=-1*h/(2*a);return[new Point(i.x+f*o,i.y+f*s)]}var c=(-1*h+Math.sqrt(u))/(2*a),y=new Point(i.x+c*o,i.y+c*s);c=(-1*h-Math.sqrt(u))/(2*a);var l=new Point(i.x+c*o,i.y+c*s);return"x"===n&&y.x<=l.x||"y"===n&&y.y<=l.y?[y,l]:[l,y]}function lineIntersectsCircle(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=beamIntersectsCircle(t,e,i,r,n);if(!1===o)return!1;if(1===o.length)return!!pointOnLine(i,r,o[0])&&o;var s=o[0],a=o[1];return!(!pointOnLine(i,r,s,5)&&!pointOnLine(i,r,a,5))&&(pointOnLine(i,r,s,5)&&pointOnLine(i,r,a,5)?"x"===n&&s.x<=a.x||"y"===n&&s.y<=a.y?[s,a]:[a,s]:pointOnLine(i,r,s,5)?[s]:pointOnLine(i,r,a,5)?[a]:void 0)}function curveEdge(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,r=1/0,n=1/0,o=void 0;"bottom"===e&&(n=-1/0),"right"===e&&(r=-1/0);for(var s=0;s<i;s++)o=t.get(s/i),("top"===e&&o.y<n||"bottom"===e&&o.y>n||"right"===e&&o.x>r||"left"===e&&o.x<r)&&(r=o.x,n=o.y);return new Point(r,n)}function stretchToScale(t){return 1/(1+parseFloat(t))}function round(t){return Math.round(100*t)/100}function sampleStyle(t,e){return"stroke: hsl("+330/e*(t-1)+", 100%, 35%);"}var utils$1=Object.freeze({capitalize:capitalize,macroName:macroName,beamsIntersect:beamsIntersect,linesIntersect:linesIntersect,pointOnBeam:pointOnBeam,pointOnLine:pointOnLine,pointOnCurve:pointOnCurve,beamIntersectsX:beamIntersectsX,beamIntersectsY:beamIntersectsY,units:units,lineIntersectsCurve:lineIntersectsCurve,curvesIntersect:curvesIntersect,circlesIntersect:circlesIntersect,beamIntersectsCircle:beamIntersectsCircle,lineIntersectsCircle:lineIntersectsCircle,curveEdge:curveEdge,stretchToScale:stretchToScale,round:round,sampleStyle:sampleStyle}),_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},_extends=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var r in i)Object.prototype.hasOwnProperty.call(i,r)&&(t[r]=i[r])}return t};function Path(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new Attributes,this.ops=[]}function pathOffset(t,e){var i=[],r=void 0,n=!1;for(var o in t.ops){var s=t.ops[o];if("line"===s.type){var a=offsetLine(r,s.to,e);a&&i.push(a)}else if("curve"===s.type){var h=void 0,p=void 0;h=r.sitsRoughlyOn(s.cp1)?(new Path).move(r).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,p=s.cp2.sitsRoughlyOn(s.to)?(new Path).move(s.to).curve(s.cp2,s.cp1,r).shiftAlong(2):s.cp2;var u=new bezierJs({x:r.x,y:r.y},{x:h.x,y:h.y},{x:p.x,y:p.y},{x:s.to.x,y:s.to.y}),f=!0,c=!1,y=void 0;try{for(var l,v=u.offset(e)[Symbol.iterator]();!(f=(l=v.next()).done);f=!0){var d=l.value;i.push(asPath(d))}}catch(t){c=!0,y=t}finally{try{!f&&v.return&&v.return()}finally{if(c)throw y}}}else"close"===s.type&&(n=!0);s.to&&(r=s.to)}return joinPaths(i,n)}function offsetLine(t,e,i){if(t.x===e.x&&t.y===e.y)return!1;var r=t.angle(e)-90;return(new Path).move(t.shift(r,i)).line(e.shift(r,i))}function asPath(t){return(new Path).move(new Point(t.points[0].x,t.points[0].y)).curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}function joinPaths(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=(new Path).move(t[0].ops[0].to),r=void 0,n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=!0,f=!1,c=void 0;try{for(var y,l=p.ops[Symbol.iterator]();!(u=(y=l.next()).done);u=!0){var v=y.value;if("curve"===v.type)i.curve(v.cp1,v.cp2,v.to);else{if("close"===v.type)throw"Cannot join a closed paths with another";r&&!v.to.sitsRoughlyOn(r)&&i.line(v.to)}v.to&&(r=v.to)}}catch(t){f=!0,c=t}finally{try{!u&&l.return&&l.return()}finally{if(f)throw c}}}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return e&&i.close(),i}function shiftAlongBezier(t,e){for(var i=void 0,r=void 0,n=void 0,o=void 0,s=0,a=0;a<=100;a++){if(n=a/100,r=new Point((r=e.get(n)).x,r.y),a>0){if(s+(o=r.dist(i))>t)return r;s+=o}i=r}}function lineBoundingBox(t){var e=t.from,i=t.to;return e.x===i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.y===i.y?e.x<i.x?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.x<i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:new Point(e.x,i.y),bottomRight:new Point(i.x,e.y)}:e.x>i.x?e.y<i.y?{topLeft:new Point(i.x,e.y),bottomRight:new Point(e.x,i.y)}:{topLeft:new Point(i.x,i.y),bottomRight:new Point(e.x,e.y)}:void 0}function curveBoundingBox(t){var e=t.bbox();return{topLeft:new Point(e.x.min,e.y.min),bottomRight:new Point(e.x.max,e.y.max)}}function bbbbox(t){var e=1/0,i=-1/0,r=1/0,n=-1/0,o=!0,s=!1,a=void 0;try{for(var h,p=t[Symbol.iterator]();!(o=(h=p.next()).done);o=!0){var u=h.value;u.topLeft.x<e&&(e=u.topLeft.x),u.topLeft.y<r&&(r=u.topLeft.y),u.bottomRight.x>i&&(i=u.bottomRight.x),u.bottomRight.y>n&&(n=u.bottomRight.y)}}catch(t){s=!0,a=t}finally{try{!o&&p.return&&p.return()}finally{if(s)throw a}}return{topLeft:new Point(e,r),bottomRight:new Point(i,n)}}function edgeCurveAsBezier(t){return new bezierJs({x:t.from.x,y:t.from.y},{x:t.cp1.x,y:t.cp1.y},{x:t.cp2.x,y:t.cp2.y},{x:t.to.x,y:t.to.y})}function addIntersectionsToArray(t,e){if(t&&"object"===(void 0===t?"undefined":_typeof(t)))if("number"==typeof t.x)e.push(t);else{var i=!0,r=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value;e.push(a)}}catch(t){r=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(r)throw n}}}}function Snippet(t,e){return this.def=t,this.anchor=e,this.attributes=new Attributes,this}function Part(){return this.attributes=new Attributes,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=utils$1,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this}Path.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},Path.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},Path.prototype.curve=function(t,e,i){return this.ops.push({type:"curve",cp1:t,cp2:e,to:i}),this},Path.prototype.close=function(){return this.ops.push({type:"close"}),this},Path.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Path.prototype.asPathstring=function(){var t="",e=!0,i=!1,r=void 0;try{for(var n,o=this.ops[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}return t},Path.prototype.offset=function(t){return pathOffset(this,t)},Path.prototype.length=function(){var t=void 0,e=void 0,i=0;for(var r in this.ops){var n=this.ops[r];"move"===n.type?e=n.to:"line"===n.type?i+=t.dist(n.to):"curve"===n.type?i+=new bezierJs({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).length():"close"===n.type&&(i+=t.dist(e)),n.to&&(t=n.to)}return round(i)},Path.prototype.start=function(){return this.ops[0].to},Path.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},Path.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,e=new Point(1/0,1/0),i=new Point(-1/0,-1/0),r=[];for(var n in this.ops){var o=this.ops[n];if("move"===o.type||"line"===o.type)o.to.x<e.x&&(e.x=o.to.x,r.leftOp=n),o.to.y<e.y&&(e.y=o.to.y,r.topOp=n),o.to.x>i.x&&(i.x=o.to.x,r.rightOp=n),o.to.y>i.y&&(i.y=o.to.y,r.bottomOp=n);else if("curve"===o.type){var s=new bezierJs({x:t.x,y:t.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}).bbox();s.x.min<e.x&&(e.x=s.x.min,r.leftOp=n),s.y.min<e.y&&(e.y=s.y.min,r.topOp=n),s.x.max>i.x&&(i.x=s.x.max,r.rightOp=n),s.y.max>i.y&&(i.y=s.y.max,r.bottomOp=n)}o.to&&(t=o.to)}this.topLeft=e,this.bottomRight=i;for(var a=["top","left","bottom","right"],h=0;h<a.length;h++){var p=a[h]+"Op";this[p]=this.ops[r[p]],this[p].from="move"===this[p].type?this[p].to:this.ops[r[p]-1].to}return this},Path.prototype.clone=function(){var t=new Path;for(var e in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var i=this.ops[e];t.ops[e]={type:i.type},"move"===i.type||"line"===i.type?t.ops[e].to=i.to.clone():"curve"===i.type&&(t.ops[e].to=i.to.clone(),t.ops[e].cp1=i.cp1.clone(),t.ops[e].cp2=i.cp2.clone())}return t},Path.prototype.join=function(t){return joinPaths([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},Path.prototype.shiftAlong=function(t){var e=0,i=void 0;for(var r in this.ops){var n=this.ops[r];if("line"===n.type){var o=n.to.dist(i);if(e+o>t)return i.shiftTowards(n.to,t-e);e+=o}else if("curve"===n.type){var s=new bezierJs({x:i.x,y:i.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}),a=s.length();if(e+a>t)return shiftAlongBezier(t-e,s);e+=a}i=n.to}throw"Ran out of path to shift along"},Path.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},Path.prototype.bbox=function(){var t=[],e=void 0;for(var i in this.ops){var r=this.ops[i];"line"===r.type?t.push(lineBoundingBox({from:e,to:r.to})):"curve"===r.type&&t.push(curveBoundingBox(new bezierJs({x:e.x,y:e.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y}))),r.to&&(e=r.to)}return bbbbox(t)},Path.prototype.reverse=function(){var t=[],e=void 0,i=!1;for(var r in this.ops){var n=this.ops[r];"line"===n.type?n.to.sitsOn(e)||t.push((new Path).move(n.to).line(e)):"curve"===n.type?t.push((new Path).move(n.to).curve(n.cp2,n.cp1,e)):"close"===n.type&&(i=!0),n.to&&(e=n.to)}var o=(new Path).move(e),s=!0,a=!1,h=void 0;try{for(var p,u=t.reverse()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;o.ops.push(f.ops[1])}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return i&&o.close(),o},Path.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new Point(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new Point(this.topLeft.x,this.bottomRight.y);var e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return curveEdge(edgeCurveAsBezier(this[e]),t)}},Path.prototype.divide=function(){var t=[],e=void 0,i=void 0;for(var r in this.ops){var n=this.ops[r];"move"===n.type?i=n.to:"line"===n.type?n.to.sitsRoughlyOn(e)||t.push((new Path).move(e).line(n.to)):"curve"===n.type?t.push((new Path).move(e).curve(n.cp1,n.cp2,n.to)):"close"===n.type&&t.push((new Path).move(e).line(i)),n.to&&(e=n.to)}return t},Path.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},Path.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},Path.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],e=arguments[1];if(!1===t)throw"Path.intersects[X-Y] requires an value as parameter";var i=[],r="x"===e?new Point(t,-1e5):new Point(-1e4,t),n="x"===e?new Point(t,1e5):new Point(1e5,t),o=!0,s=!1,a=void 0;try{for(var h,p=this.divide()[Symbol.iterator]();!(o=(h=p.next()).done);o=!0){var u=h.value;"line"===u.ops[1].type?addIntersectionsToArray(linesIntersect(u.ops[0].to,u.ops[1].to,r,n),i):"curve"===u.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(r,n,u.ops[0].to,u.ops[1].cp1,u.ops[1].cp2,u.ops[1].to),i)}}catch(t){s=!0,a=t}finally{try{!o&&p.return&&p.return()}finally{if(s)throw a}}return i},Path.prototype.intersects=function(t){if(this===t)throw"Calculating intersections between two identical paths is bad idea";var e=[],i=!0,r=!1,n=void 0;try{for(var o,s=this.divide()[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value,h=!0,p=!1,u=void 0;try{for(var f,c=t.divide()[Symbol.iterator]();!(h=(f=c.next()).done);h=!0){var y=f.value;"line"===a.ops[1].type?"line"===y.ops[1].type?addIntersectionsToArray(linesIntersect(a.ops[0].to,a.ops[1].to,y.ops[0].to,y.ops[1].to),e):"curve"===y.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(a.ops[0].to,a.ops[1].to,y.ops[0].to,y.ops[1].cp1,y.ops[1].cp2,y.ops[1].to),e):"curve"===a.ops[1].type&&("line"===y.ops[1].type?addIntersectionsToArray(lineIntersectsCurve(y.ops[0].to,y.ops[1].to,a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to),e):"curve"===y.ops[1].type&&addIntersectionsToArray(curvesIntersect(a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to,y.ops[0].to,y.ops[1].cp1,y.ops[1].cp2,y.ops[1].to),e))}}catch(t){p=!0,u=t}finally{try{!h&&c.return&&c.return()}finally{if(p)throw u}}}}catch(t){r=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(r)throw n}}return e},Path.prototype.split=function(t){var e=this.divide(),i=!1,r=!1;for(var n in e){var o=e[n];if("line"===o.ops[1].type)pointOnLine(o.ops[0].to,o.ops[1].to,t)&&((i=e.slice(0,n)).push((new Path).move(o.ops[0].to).line(t)),n++,(r=e.slice(n)).unshift((new Path).move(t).line(o.ops[1].to)));else if("curve"===o.ops[1].type){var s=pointOnCurve(o.ops[0].to,o.ops[1].cp1,o.ops[1].cp2,o.ops[1].to,t);if(!1!==s){var a=new bezierJs({x:o.ops[0].to.x,y:o.ops[0].to.y},{x:o.ops[1].cp1.x,y:o.ops[1].cp1.y},{x:o.ops[1].cp2.x,y:o.ops[1].cp2.y},{x:o.ops[1].to.x,y:o.ops[1].to.y}).split(s);(i=e.slice(0,n)).push((new Path).move(new Point(a.left.points[0].x,a.left.points[0].y)).curve(new Point(a.left.points[1].x,a.left.points[1].y),new Point(a.left.points[2].x,a.left.points[2].y),new Point(a.left.points[3].x,a.left.points[3].y))),n++,(r=e.slice(n)).unshift((new Path).move(new Point(a.right.points[0].x,a.right.points[0].y)).curve(new Point(a.right.points[1].x,a.right.points[1].y),new Point(a.right.points[2].x,a.right.points[2].y),new Point(a.right.points[3].x,a.right.points[3].y)))}}}return i&&(i=joinPaths(i)),r&&(r=joinPaths(r)),[i,r]},Path.prototype.trim=function(){var t=this.divide();for(var e in t)for(var i=parseInt(e)+2,r=parseInt(t.length)-1,n=i;n<r;n++){var o=t[e].intersects(t[n]);if(o.length>0){for(var s=o.pop(),a=t.slice(0,e),h=t.slice(parseInt(n)+1),p=new Path,u=!0,f=[e,n],c=0;c<f.length;c++){var y=t[f[c]].ops;if("line"===y[1].type)p.line(s);else if("curve"===y[1].type){var l=new bezierJs({x:y[0].to.x,y:y[0].to.y},{x:y[1].cp1.x,y:y[1].cp1.y},{x:y[1].cp2.x,y:y[1].cp2.y},{x:y[1].to.x,y:y[1].to.y}),v=pointOnCurve(y[0].to,y[1].cp1,y[1].cp2,y[1].to,s),d=l.split(v),x=void 0;x=u?d.left:d.right,p.curve(new Point(x.points[1].x,x.points[1].y),new Point(x.points[2].x,x.points[2].y),new Point(x.points[3].x,x.points[3].y))}u=!1}var g=void 0;return g=a.length>0?joinPaths(a).join(p):p,h.length>0&&(g=g.join(joinPaths(h))),g.trim()}}return this},Path.prototype.translate=function(t,e){var i=this.clone(),r=!0,n=!1,o=void 0;try{for(var s,a=i.ops[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;"close"!==h.type&&(h.to=h.to.translate(t,e)),"curve"===h.type&&(h.cp1=h.cp1.translate(t,e),h.cp2=h.cp2.translate(t,e))}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}return i},Snippet.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Snippet.prototype.clone=function(){var t=new Snippet(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},Part.prototype.macroClosure=function(t){var e=this;return function(t,i){var r=macroName(t);"function"==typeof e[r]?e[r](i):e.debug("warning","🚨 Macro not found","Macro "+r.substr(7)+" is not registered")}},Part.prototype.debugClosure=function(){var t=this;return function(e,i,r,n,o){t.debug(e,i,r,n,o)}},Part.prototype.debug=function(t){},Part.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Part.prototype.unitsClosure=function(t){var e=this;return function(t){return units(t,e.context.settings.units)}},Part.prototype.boundary=function(){if(this.topLeft)return this;var t=new Point(1/0,1/0),e=new Point(-1/0,-1/0);for(var i in this.paths){var r=this.paths[i].boundary();r.render&&(r.topLeft.x<t.x&&(t.x=r.topLeft.x),r.topLeft.y<t.y&&(t.y=r.topLeft.y),r.bottomRight.x>e.x&&(e.x=r.bottomRight.x),r.bottomRight.y>e.y&&(e.y=r.bottomRight.y))}for(var n in this.points){var o=this.points[n],s=o.attributes.get("data-circle");s&&(s=parseFloat(s),o.x-s<t.x&&(t.x=o.x-s),o.y-s<t.y&&(t.y=o.y-s),o.x+s>e.x&&(e.x=o.x+s),o.y+s>e.y&&(e.y=o.y+s))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),e.x===-1/0&&(e.x=0),e.y===-1/0&&(e.y=0);var a=this.context.settings.margin;return this.context.settings.paperless&&a<10&&(a=10),this.topLeft=new Point(t.x-a,t.y-a),this.bottomRight=new Point(e.x+a,e.y+a),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},Part.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},Part.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Part.prototype.inject=function(t){for(var e=["points","paths","snippets"],i=0;i<e.length;i++){var r=e[i];for(var n in t[r])void 0===this[r][n]&&(this[r][n]=t[r][n].clone())}return this},Part.prototype.units=function(t){return units(t,this.context.settings.units)},Part.prototype.shorthand=function(){var t=!!this.context.settings.complete,e=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:utils$1,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:e,debug:this.debugClosure()}};var version="0.22.1";function Svg(t){this.openGroups=[],this.freeId=0,this.body="",this.style="",this.script="",this.header="",this.footer="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new Attributes,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",version)}Svg.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var i=this.hooks[t];if(i.length>0){var r=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;h.method(e,h.data)}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}}},Svg.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var e=!0,i=!1,r=void 0;try{for(var n,o=this.hooks.insertText[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;t=s.method(t,s.data)}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}}return t},Svg.prototype.debug=function(){},Svg.prototype.render=function(t){for(var e in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.svg=this.prefix,this.svg+=this.renderComments(this.header),this.svg+=this.renderSvgTag(t),this.svg+=this.renderStyle(),this.svg+=this.renderScript(),this.svg+=this.renderDefs(),this.svg+=this.openGroup(this.idPrefix+"container"),t.parts){var i=t.parts[e];i.render&&t.needs(e)&&(this.svg+=this.openGroup(this.idPrefix+"part-"+e,i.attributes),this.svg+=this.renderPart(i),this.svg+=this.closeGroup())}return this.svg+=this.closeGroup(),this.svg+=this.nl()+"</svg>",this.svg+=this.renderComments(this.footer),this.runHooks("postRender"),this.svg},Svg.prototype.renderSvgTag=function(t){var e="<svg";return this.indent(),e+=this.nl()+this.attributes.render(),this.outdent(),e+=this.nl()+">"+this.nl()},Svg.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},Svg.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},Svg.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},Svg.prototype.renderComments=function(t){return this.nl()+this.nl()+"\x3c!--"+this.nl()+t+this.nl()+"--\x3e"},Svg.prototype.renderPart=function(t){var e="";for(var i in t.paths){var r=t.paths[i];r.render&&(e+=this.renderPath(r))}for(var n in t.points)t.points[n].attributes.get("data-text")&&(e+=this.renderText(t.points[n])),t.points[n].attributes.get("data-circle")&&(e+=this.renderCircle(t.points[n]));for(var o in t.snippets){var s=t.snippets[o];e+=this.renderSnippet(s,t)}return e},Svg.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},Svg.prototype.renderPathText=function(t){var e=t.attributes.get("data-text");if(!e)return"";this.text=this.insertText(e);var i=t.attributes.renderIfPrefixIs("data-text-"),r="",n=t.attributes.get("data-text-class");n&&n.indexOf("center")>-1?r=' startOffset="50%" ':n&&n.indexOf("right")>-1&&(r=' startOffset="100%" ');var o=this.nl()+"<text>";return this.indent(),o+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+r+"><tspan "+i+">"+this.text+"</tspan></textPath>",this.outdent(),o+=this.nl()+"</text>"},Svg.prototype.renderText=function(t){var e=t.attributes.getAsArray("data-text");if(!1!==e){var i="",r=!0,n=!1,o=void 0;try{for(var s,a=e[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;this.text=this.insertText(h),i+=this.text+" "}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}this.text=this.insertText(i)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var p=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var f=this.text.split("\n");u+="<tspan>"+f.shift()+"</tspan>";var c=!0,y=!1,l=void 0;try{for(var v,d=f[Symbol.iterator]();!(c=(v=d.next()).done);c=!0){var x=v.value;u+='<tspan x="'+t.x+'" dy="'+p+'">'+x+"</tspan>"}}catch(t){y=!0,l=t}finally{try{!c&&d.return&&d.return()}finally{if(y)throw l}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},Svg.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},Svg.prototype.renderSnippet=function(t,e){var i=t.anchor.x,r=t.anchor.y,n=t.attributes.get("data-scale");n&&(t.attributes.add("transform","translate("+i+", "+r+")"),t.attributes.add("transform","scale("+n+")"),t.attributes.add("transform","translate("+-1*i+", "+-1*r+")"));var o=t.attributes.get("data-rotate");o&&t.attributes.add("transform","rotate("+o+", "+i+", "+r+")");var s=this.nl();return s+='<use x="'+i+'" y="'+r+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},Svg.prototype.openGroup=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.nl()+this.nl();return i+="\x3c!-- Start of group #"+t+" --\x3e",i+=this.nl(),i+='<g id="'+t+'"',e&&(i+=" "+e.render()),i+=">",this.indent(),this.openGroups.push(t),i},Svg.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},Svg.prototype.nl=function(){return"\n"+this.tab()},Svg.prototype.tab=function(){for(var t="",e=0;e<this.tabs;e++)t+="  ";return t},Svg.prototype.indent=function(){this.tabs+=1},Svg.prototype.outdent=function(){this.tabs-=1},Svg.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var GrowingPacker=function(){};GrowingPacker.prototype={fit:function(t){var e,i,r,n,o=t.length,s=o>0?t[0].width:0,a=o>0?t[0].height:0;for(this.root={x:0,y:0,width:s,height:a},e=0;e<o;e++)r=t[e],(i=this.findNode(this.root,r.width,r.height))?(n=this.splitNode(i,r.width,r.height),r.x=n.x,r.y=n.y):(n=this.growNode(r.width,r.height),r.x=n.x,r.y=n.y)},findNode:function(t,e,i){return t.used?this.findNode(t.right,e,i)||this.findNode(t.down,e,i):e<=t.width&&i<=t.height?t:null},splitNode:function(t,e,i){return t.used=!0,t.down={x:t.x,y:t.y+i,width:t.width,height:t.height-i},t.right={x:t.x+e,y:t.y,width:t.width-e,height:i},t},growNode:function(t,e){var i=t<=this.root.width,r=e<=this.root.height,n=r&&this.root.height>=this.root.width+t,o=i&&this.root.width>=this.root.height+e;return n?this.growRight(t,e):o?this.growDown(t,e):r?this.growRight(t,e):i?this.growDown(t,e):null},growRight:function(t,e){var i;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(i=this.findNode(this.root,t,e))?this.splitNode(i,t,e):null},growDown:function(t,e){var i;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+e,down:{x:0,y:this.root.height,width:this.root.width,height:e},right:this.root},(i=this.findNode(this.root,t,e))?this.splitNode(i,t,e):null}};var packer_growing=GrowingPacker,binPack=function(t,e){e=e||{};var i=new packer_growing,r=e.inPlace||!1,n=t.map(function(t){return r?t:{width:t.width,height:t.height,item:t}});n=n.sort(function(t,e){return e.width*e.height-t.width*t.height}),i.fit(n);var o={width:n.reduce(function(t,e){return Math.max(t,e.x+e.width)},0),height:n.reduce(function(t,e){return Math.max(t,e.y+e.height)},0)};return r||(o.items=n),o};function Store(){this.data=new Map}Store.prototype.set=function(t,e){this.data.set(t,e)},Store.prototype.setIfUnset=function(t,e){this.data.has(t)||this.data.set(t,e)},Store.prototype.get=function(t){return this.data.get(t)};var hooks={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function Pattern(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];for(var e in this.config=t||{},this.width=!1,this.height=!1,this.is="",this.store=new Store,this.parts={},this.hooks=hooks,this.Part=Part,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies),t.options){var i=t.options[e];if("object"===(void 0===i?"undefined":_typeof(i)))if(void 0!==i.pct)this.settings.options[e]=i.pct/100;else if(void 0!==i.mm)this.settings.options[e]=i.mm;else if(void 0!==i.deg)this.settings.options[e]=i.deg;else if(void 0!==i.count)this.settings.options[e]=i.count;else{if(void 0===i.dflt)throw"Unknown option type";this.settings.options[e]=i.dflt}else this.settings.options[e]=i}this.context={parts:this.parts,config:this.config,settings:this.settings,store:this.store}}Pattern.prototype.createPart=function(){var t=new Part;return t.context=this.context,t},Pattern.prototype.mergeSettings=function(t){var e=!0,i=!1,r=void 0;try{for(var n,o=Object.keys(t)[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;"object"===_typeof(t[s])?this.settings[s]=_extends({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}},Pattern.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var i=this.hooks[t];if(i.length>0){var r=!0,n=!1,o=void 0;try{for(var s,a=i[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;h.method(e,h.data)}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}}},Pattern.prototype.draft=function(){this.is="draft",this.runHooks("preDraft");var t=!0,e=!1,i=void 0;try{for(var r,n=this.config.draftOrder[Symbol.iterator]();!(t=(r=n.next()).done);t=!0){var o=r.value,s=this.createPart();if("string"==typeof this.config.inject[o]&&s.inject(this.parts[this.config.inject[o]]),this.needs(o)){var a="draft"+capitalize(o);if("function"!=typeof this[a])throw new Error('Method "'+a+'" on pattern object is not callable');this.parts[o]=this[a](s),this.parts[o].render=this.wants(o)}}}catch(t){e=!0,i=t}finally{try{!t&&n.return&&n.return()}finally{if(e)throw i}}return this.runHooks("postDraft"),this},Pattern.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},Pattern.prototype.sampleParts=function(){var t={};for(var e in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[e]=this.createPart(),t[e].render=this.parts[e].render;return t},Pattern.prototype.sampleRun=function(t,e,i,r){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var o in this.draft(),this.parts){var s=0,a=0;for(var h in this.parts[o].points.anchor&&(void 0===e[o]?e[o]=this.parts[o].points.anchor:e[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(e[o]),a=this.parts[o].points.anchor.dy(e[o]))),this.parts[o].paths)t[o].paths[h+"_"+i]=this.parts[o].paths[h].clone().attr("style",sampleStyle(i,r)),this.parts[o].points.anchor&&(t[o].paths[h+"_"+i]=t[o].paths[h+"_"+i].translate(s,a)),!1!==n&&t[o].paths[h+"_"+i].attributes.add("class",n)}},Pattern.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var e,i=void 0,r=1,n={},o=this.sampleParts(),s=this.config.options[t];if("object"===_typeof(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(r=100),i=s.min/r,e=(s.max/r-i)/9;for(var a=1;a<11;a++)this.settings.options[t]=i,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+round(i)),this.sampleRun(o,n,a,10),i+=e;return this.parts=o,this.runHooks("postSample"),this},Pattern.prototype.sampleListOption=function(t){var e=this.sampleParts(),i=this.config.options[t],r={},n=1,o=i.list.length,s=!0,a=!1,h=void 0;try{for(var p,u=i.list[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;this.settings.options[t]=f,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+round(f)),this.sampleRun(e,r,n,o),n++}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return this.parts=e,this},Pattern.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var e={},i=this.sampleParts(),r=this.settings.measurements[t];if(void 0===r)throw"Cannot sample a measurement that is undefined";var n=r/50;r*=.9;for(var o=1;o<11;o++)this.settings.measurements[t]=r,this.debug("info","🏃🏿‍♀️ Sample run","Sampling measurement "+t+" with value "+round(r)),this.sampleRun(i,e,o,10),r+=n;return this.parts=i,this.runHooks("postSample"),this},Pattern.prototype.sampleModels=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var i={},r=this.sampleParts(),n=0,o=Object.keys(t).length;for(var s in t){n++,this.settings.measurements=t[s],this.debug("info","🏃🏿‍♀️ Sample run","Sampling model "+s);var a=s===e?"sample-focus":"";this.sampleRun(r,i,n,o,a)}return this.parts=r,this.runHooks("postSample"),this},Pattern.prototype.debug=function(){for(var t=arguments.length,e=Array(t),i=0;i<t;i++)e[i]=arguments[i];this.runHooks("debug",e)},Pattern.prototype.render=function(){return this.svg=new Svg(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},Pattern.prototype.on=function(t,e,i){this.hooks[t].push({method:e,data:i})},Pattern.prototype.with=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug("success","🔌 Plugin loaded",t.name+" v"+t.version),t.hooks&&this.loadPluginHooks(t,e),t.macros&&this.loadPluginMacros(t),this},Pattern.prototype.loadPluginHooks=function(t,e){var i=!0,r=!1,n=void 0;try{for(var o,s=Object.keys(this.hooks)[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value;if("function"==typeof t.hooks[a])this.on(a,t.hooks[a],e);else if("object"===_typeof(t.hooks[a])){var h=!0,p=!1,u=void 0;try{for(var f,c=t.hooks[a][Symbol.iterator]();!(h=(f=c.next()).done);h=!0){var y=f.value;this.on(a,y,e)}}catch(t){p=!0,u=t}finally{try{!h&&c.return&&c.return()}finally{if(p)throw u}}}}}catch(t){r=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(r)throw n}}},Pattern.prototype.loadPluginMacros=function(t){for(var e in t.macros)"function"==typeof t.macros[e]&&this.macro(e,t.macros[e])},Pattern.prototype.macro=function(t,e){this.Part.prototype[macroName(t)]=e},Pattern.prototype.pack=function(){var t=[];for(var e in this.parts){var i=this.parts[e];i.attributes.set("transform",""),i.render&&this.needs(e)&&(i.stack(),t.push({id:e,width:i.bottomRight.x-i.topLeft.x,height:i.bottomRight.y-i.topLeft.y}))}var r=binPack(t,{inPlace:!0}),n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=this.parts[p.id];0===p.x&&0===p.y||u.attr("transform","translate ("+p.x+", "+p.y+")")}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return this.width=r.width,this.height=r.height,this},Pattern.prototype.draftOrder=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.resolveDependencies(),e=[],i={};return Object.keys(t).forEach(function r(n,o){Array.isArray(o)||(o=[]),o.push(n),i[n]=!0,void 0!==t[n]&&t[n].forEach(function(t){if(o.indexOf(t)>=0)throw new Error('Circular dependency "'+t+'" is required by "'+n+'": '+o.join(" -> "));i[t]||r(t,o.slice(0))}),e.indexOf(n)<0&&e.push(n)}),e},Pattern.prototype.resolveDependency=function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.config.dependencies,r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];return void 0===t[e]&&(t[e]=!0),"string"==typeof i[e]?(r.push(i[e]),this.resolveDependency(t,i[e],i,r)):r},Pattern.prototype.resolveDependencies=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.config.dependencies,e={},i={},r=!0,n=!1,o=void 0;try{for(var s,a=Object.keys(t)[Symbol.iterator]();!(r=(s=a.next()).done);r=!0){var h=s.value;e[h]=this.resolveDependency(i,h,t)}}catch(t){n=!0,o=t}finally{try{!r&&a.return&&a.return()}finally{if(n)throw o}}var p=!0,u=!1,f=void 0;try{for(var c,y=Object.keys(i)[Symbol.iterator]();!(p=(c=y.next()).done);p=!0){var l=c.value;void 0===e[l]&&(e[l]=[])}}catch(t){u=!0,f=t}finally{try{!p&&y.return&&y.return()}finally{if(u)throw f}}return e},Pattern.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only])){var e=!0,i=!1,r=void 0;try{for(var n,o=this.config.resolvedDependencies[this.settings.only][Symbol.iterator]();!(e=(n=o.next()).done);e=!0){if(n.value===t)return!0}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}}}else if(Array.isArray(this.settings.only)){var s=!0,a=!1,h=void 0;try{for(var p,u=this.settings.only[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;if(f===t)return!0;var c=!0,y=!1,l=void 0;try{for(var v,d=this.config.resolvedDependencies[f][Symbol.iterator]();!(c=(v=d.next()).done);c=!0){if(v.value===t)return!0}}catch(t){y=!0,l=t}finally{try{!c&&d.return&&d.return()}finally{if(y)throw l}}}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}}return!1},Pattern.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},Pattern.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){var e=!0,i=!1,r=void 0;try{for(var n,o=this.settings.only[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){if(n.value===t)return!0}}catch(t){i=!0,r=t}finally{try{!e&&o.return&&o.return()}finally{if(i)throw r}}return!1}}return!0};var index={version:version,Pattern:Pattern,Point:Point,Path:Path,Snippet:Snippet,utils:utils$1,patterns:{},plugins:{}};export default index;
//# sourceMappingURL=index.mjs.map
